Package: ROntoTools
Type: Package
Title: R Onto-Tools suite
Version: 2.38.0
Author: Calin Voichita <calin@wayne.edu> and Sahar Ansari
    <saharansari@wayne.edu> and Sorin Draghici <sorin@advaitabio.com>
Maintainer: Sorin Draghici <sorin@advaitabio.com>
Description: Suite of tools for functional analysis.
biocViews: NetworkAnalysis, Microarray, GraphsAndNetworks
License: CC BY-NC-ND 4.0 + file LICENSE
Depends: methods, graph, boot, KEGGREST, KEGGgraph, Rgraphviz
Suggests: RUnit, BiocGenerics
RoxygenNote: 5.0.1
git_url: https://git.bioconductor.org/packages/ROntoTools
git_branch: RELEASE_3_22
git_last_commit: 5e9ce05
git_last_commit_date: 2025-10-29
Repository: Bioconductor 3.22
Date/Publication: 2025-10-29
NeedsCompilation: no
Packaged: 2025-10-30 06:09:13 UTC; biocbuild

#' Summarize the results of a Pathway-Express analysis
#' 
#' @param x Pathway-Express analysis result object obtained using \code{\link{pe}}
#' @param ... see \code{\link{summary.peRes}}
#' @param na.rm ignored
#'
#' @aliases Summary,peRes-method
#'
#' @export
setMethod("Summary", c("x" = "peRes"),
  function(x, ..., na.rm = FALSE) {
    return(summary.peRes(x, ...));
  }
)

#' Summarize the results of a Pathway-Express analysis
#' 
#' @param x Primary dis-regulation analysis result object obtained using \code{\link{pDis}}
#' @param ... see \code{\link{summary.pDisRes}}
#' @param na.rm ignored
#'
#' @aliases Summary,pDisRes-method
#'
#' @export
setMethod("Summary", c("x" = "pDisRes"),
  function(x, ..., na.rm = FALSE) {
    return(summary.pDisRes(x, ...));
  }
)

#' Summarize the results of a Pathway-Express analysis
#' 
#' 
#' @usage summary.peRes(object, ..., pathNames = NULL, totalAcc = TRUE, totalPert = TRUE, normalize = TRUE, 
#'  pPert = TRUE, pAcc = TRUE, pORA = TRUE, 
#'  comb.pv = c("pPert", "pORA"), comb.pv.func = compute.fisher,
#'  order.by = "pComb", adjust.method = "fdr")
#' 
#' @param object Pathways-Express result object obtained using \code{\link{pe}}
#' @param ... ignored
#' @param pathNames named vector of pathway names; the names of the vector are the IDs of the pathways
#' @param totalAcc boolean value indicating if the total accumulation should be computed
#' @param totalPert boolean value indicating if the total perturbation should be computed
#' @param normalize boolean value indicating if normalization with regards to the boostrap simulations should be performed on totalAcc and totalPert
#' @param pPert boolean value indicating if the significance of the total perturbation in regards to the bootstrap permutations should be computed
#' @param pAcc boolean value indicating if the significance of the total accumulation in regards to the bootstrap permutations should be computed
#' @param pORA boolean value indicating if the over-represtation p-value should be computed
#' @param comb.pv vector of the p-value names to be combine (any of the above p-values)
#' @param comb.pv.func the function to combine the p-values; takes as input a vector of p-values and returns the combined p-value
#' @param order.by the name of the p-value that is used to order the results
#' @param adjust.method the name of the method to adjust the p-value (see \link{p.adjust})
#' 
#' @seealso \code{\link{pe}}
#' 
#' @examples
#' 
#' # load experiment
#' load(system.file("extdata/E-GEOD-21942.topTable.RData", package = "ROntoTools"))
#' fc <- top$logFC[top$adj.P.Val <= .01]
#' names(fc) <- top$entrez[top$adj.P.Val <= .01]
#' ref <- top$entrez
#' 
#' # load the set of pathways
#' kpg <- keggPathwayGraphs("hsa")
#' kpg <- setEdgeWeights(kpg)
#' kpg <- setNodeWeights(kpg, defaultWeight = 1)
#' 
#' # perform the pathway analysis
#' peRes <- pe(fc, graphs = kpg, ref = ref, nboot = 100, verbose = TRUE)
#' 
#' # obtain summary of results
#' head(summary(peRes))
#' 
#' kpn <- keggPathwayNames("hsa")
#' 
#' head(summary(peRes))
#' 
#' head(summary(peRes, pathNames = kpn, totalAcc = FALSE, totalPert = FALSE, 
#'              pAcc = FALSE, pORA = FALSE, comb.pv = NULL, order.by = "pPert"))
#'
#' @export
summary.peRes <- function(object, ..., pathNames = NULL, totalAcc = TRUE, totalPert = TRUE, normalize = TRUE, 
                   pPert = TRUE, pAcc = TRUE, pORA = TRUE, 
                   comb.pv = c("pPert", "pORA"), comb.pv.func = compute.fisher,
                   order.by = "pComb", adjust.method = "fdr")
{  
  ifelse <- function(test, trueCase, falseCase){
    if(test) return(trueCase)
    else return(falseCase)
  }
  
  pathStats <- function(pePath)
  {
    pStats <- NULL
    
    pStats$totalAcc <- ifelse(totalAcc, ifelse(!pePath@asGS, get.totalAcc(pePath), NA), NULL)
    pStats$totalPert <- ifelse(totalPert, ifelse(!pePath@asGS, get.totalPert(pePath), NA), NULL)
    
    pStats$totalAccNorm <- ifelse(totalAcc & normalize, ifelse(!pePath@asGS, get.totalAccNorm(pePath), NA), NULL)
    pStats$totalPertNorm <- ifelse(totalPert & normalize, ifelse(!pePath@asGS, get.totalPertNorm(pePath), NA), NULL)
    
    pStats$pPert <- ifelse(pPert, ifelse(!pePath@asGS, compute.pPert(pePath), NA), NULL)
    pStats$pAcc <- ifelse(pAcc, ifelse(!pePath@asGS, compute.pAcc(pePath), NA), NULL)
    
    pStats$pORA <- ifelse(pORA & !object@cutOffFree, compute.pORA(pePath, length(object@input), length(object@ref)), NULL)
    
    pStats$pComb <- ifelse(!is.null(comb.pv) & !any(is.null(pStats[comb.pv])), 
                           ifelse(!any(is.na(pStats[comb.pv])), as.numeric(comb.pv.func(unlist(pStats[comb.pv]))), NA), NULL)
    
    return(unlist(pStats))
  }
  
  if (pORA & object@cutOffFree)
  {
    pORA <- FALSE
    if ("pORA" %in% comb.pv)
    {
      order.by <- setdiff(comb.pv, "pORA")[1]
      comb.pv <- NULL
    }
    message("The over-representaion p-value is not defined for cut-off free analysis and will not be computed!")  
  }
  
  if(!is.null(comb.pv))
  {
    if(!all(comb.pv %in% c("pPert","pAcc","pORA")))
    {
      warning("The p-value to be combined are not specified correctly. No combination p-value will be calculated!")
      comb.pv <- NULL
      if(order.by == "pComb")
        order.by <- NULL
    }else{
      for(i in 1:length(comb.pv))
        assign(comb.pv[i], TRUE)
    }
  }
  
  topStats <- data.frame(do.call(rbind, lapply(object@pathways, pathStats)))
  
  if(!is.null(pathNames))
  {
    pathNames <- pathNames[rownames(topStats)]
    topStats <- cbind(pathNames, topStats)
  }
  
  if(order.by %in% colnames(topStats))
  {
    topStats <- topStats[order(topStats[,order.by]),]
  }
  
  allPVs <- c("pPert","pAcc","pORA", "pComb")
  
  lapply(allPVs[allPVs %in% colnames(topStats)],
         function(pv)
           topStats[[paste(pv, "." , adjust.method, sep = "")]] <<- p.adjust(topStats[[pv]], adjust.method)
  )
  return(topStats)
}

#' Extract edge render information from a \code{pePathway-class} object
#' 
#' @param x an object of class \code{\link{pePathway-class}}
#' @param pos.col color of the edges with possitive weight
#' @param pos.lty line type of the edges with possitive weight
#' @param pos.ah arrow head of the edges with possitive weight 
#' @param neg.col color of the edges with negative weight
#' @param neg.lty line type of the edges with negative weight 
#' @param neg.ah arrow head of the edges with negative weight 
#' @param zero.col color of the edges with zero weight 
#' @param zero.lty color of the edges with zero weight
#' @param zero.ah color of the edges with zero weight
#' 
#' @return a named list as expected by \code{\link{edgeRenderInfo}}
#' 
#' @author Calin Voichita and Sorin Draghici
#' 
#' @seealso \code{\link{edgeRenderInfo}},\code{\link{par}}
#' 
#' @examples
#' 
#' # load experiment
#' load(system.file("extdata/E-GEOD-21942.topTable.RData", package = "ROntoTools"))
#' fc <- top$logFC[top$adj.P.Val <= .01]
#' names(fc) <- top$entrez[top$adj.P.Val <= .01]
#' ref <- top$entrez
#' 
#' # load the set of pathways
#' kpg <- keggPathwayGraphs("hsa")
#' kpg <- setEdgeWeights(kpg)
#' kpg <- setNodeWeights(kpg, defaultWeight = 1)
#' 
#' # perform the pathway analysis
#' peRes <- pe(fc, graphs = kpg, ref = ref, nboot = 100, verbose = TRUE)
#' 
#' p <- peRes@@pathways[[50]]
#' g <- layoutGraph(p@@map, layoutType = "dot")
#' graphRenderInfo(g) <- list(fixedsize = FALSE)
#' edgeRenderInfo(g) <- peEdgeRenderInfo(p)
#' nodeRenderInfo(g) <- peNodeRenderInfo(p)
#' # notice the different type of edges in the graph (solid/dashed/dotted) 
#' renderGraph(g)
#' 
#' @export
peEdgeRenderInfo <- function(x,
                             pos.col = "black", pos.lty = "solid", pos.ah = "vee",
                             neg.col = "black", neg.lty = "dashed", neg.ah = "tee",
                             zero.col = "lightgray", zero.lty = "dotted", zero.ah = "none")
{
  stopifnot(class(x) == "pePathway")
  
  ew <- unlist(edgeWeights(x@map))
  
  aHead <- rep(zero.ah, length(edgeNames(x@map)))
  names(aHead) <- edgeNames(x@map)
  aHead[ew > 0] <- pos.ah
  aHead[ew < 0] <- neg.ah
  aHead <- aHead[setdiff(seq(along=ew), removedEdges(x@map))]
  
  eCol <- rep(zero.col, length(edgeNames(x@map)))
  names(eCol) <- edgeNames(x@map)
  eCol[ew > 0] <- pos.col
  eCol[ew < 0] <- neg.col
  eCol <- eCol[setdiff(seq(along=ew), removedEdges(x@map))]
  
  eStyle <- rep(zero.lty, length(edgeNames(x@map)))
  names(eStyle) <- edgeNames(x@map)  
  eStyle[ew > 0] <- pos.lty
  eStyle[ew < 0] <- neg.lty
  eStyle <- eStyle[setdiff(seq(along=ew), removedEdges(x@map))]
  
  return(list(
    arrowhead = aHead,
    col = eCol,
    lty = eStyle
  ))
}

#' Extract node render information from a \code{pePathway-class} object
#' 
#' @param x an object of class \code{\link{pePathway-class}}
#' @param y a string representing the factor to be represented (\code{Pert, Acc} or \code{input}; see \code{\link{pePathway-class}})
#' @param input.shape shape of nodes that have measured expression change
#' @param default.shape shape of all other nodes
#' @param pos.col color of nodes with a positive \code{y} factor
#' @param neg.col color of nodes with a negative \code{y} factor
#' @param zero.col color of nodes with the \code{y} factor equal to zero
#' 
#' @return a named list as expected by \code{\link{nodeRenderInfo}}
#' 
#' @author Calin Voichita and Sorin Draghici
#' 
#' @seealso \code{\link{nodeRenderInfo}},\code{\link{par}}
#' 
#' @examples
#' 
#' # load experiment
#' load(system.file("extdata/E-GEOD-21942.topTable.RData", package = "ROntoTools"))
#' fc <- top$logFC[top$adj.P.Val <= .01]
#' names(fc) <- top$entrez[top$adj.P.Val <= .01]
#' ref <- top$entrez
#' 
#' # load the set of pathways
#' kpg <- keggPathwayGraphs("hsa")
#' kpg <- setEdgeWeights(kpg)
#' kpg <- setNodeWeights(kpg, defaultWeight = 1)
#' 
#' # perform the pathway analysis
#' peRes <- pe(fc, graphs = kpg, ref = ref, nboot = 100, verbose = TRUE)
#' 
#' p <- peRes@@pathways[[50]]
#' g <- layoutGraph(p@@map, layoutType = "dot")
#' graphRenderInfo(g) <- list(fixedsize = FALSE)
#' edgeRenderInfo(g) <- peEdgeRenderInfo(p)
#' nodeRenderInfo(g) <- peNodeRenderInfo(p)
#' # notice the different type of nodes in the graph (box/circle)
#' # the color of each node represents the perturbation (red = positive, blue = negative)
#' # the shade represents the stregth of the perturbation 
#' renderGraph(g)
#' 
#' nodeRenderInfo(g) <- peNodeRenderInfo(p, "Acc")
#' # now, the color of each node represents the accumulation (red = positive, blue = negative)
#' # notice that square nodes with no parents have no accumulation
#' renderGraph(g)
#' 
#' @export
peNodeRenderInfo <- function(x, y = "Pert",
                             input.shape = "box",
                             default.shape = "ellipse",
                             pos.col = "red",
                             neg.col = "blue",
                             zero.col = "white")
{
  stopifnot(class(x) == "pePathway")
  stopifnot(y %in%  c("input", "Pert", "Acc"))
  
  nShape <- rep(default.shape, length(nodes(x@map)))
  names(nShape) <- nodes(x@map)
  nShape[names(x@input)] <- input.shape
  
  nFillColor <- rep(zero.col, length(nodes(x@map)))
  names(nFillColor) <- nodes(x@map)
  pfi <- slot(x, y)
  pf <- rep(0, length(nodes(x@map)))
  names(pf) <- nodes(x@map)
  pf[names(pfi)] <- pfi
  nFillColor[pf <= 0] <- colorRampPalette(c(zero.col,neg.col))(256)[as.numeric(cut(abs(pf[pf<=0]), 256))]                                  
  nFillColor[pf >= 0] <- colorRampPalette(c(zero.col,pos.col))(256)[as.numeric(cut(abs(pf[pf>=0]), 256))]
  
  return(list(
    shape = nShape,
    fill = nFillColor
  ))
}

#' Set node weights
#' 
#' 
#' @param graphList a list of \code{graph} (e.g., \code{\link{graphNEL}}) objects
#' @param weights named vector or matrix; if vector, the node is going to have the same weight in all graphs it appears;
#'                         if matrix, the rows represent nodes and columns represent graphs and the node will have different weights in each pathway  
#' @param defaultWeight the default weight for all nodes not set by the parameter \code{weights}
#' 
#' @return
#' 
#' The \code{graphList} with the node weights set.
#' 
#' @author
#' 
#' Calin Voichita and Sorin Draghici
#' 
#' @examples
#' 
#' # load the set of pathways
#' kpg <- keggPathwayGraphs("hsa")
#' 
#' kpg <- setNodeWeights(kpg)
#' 
#' nodeWeights(kpg[["path:hsa04110"]])
#' 
#' 
#' @export
setNodeWeights <- function(graphList, weights = NULL, defaultWeight = 1)
{
  if(is.null(weights))
  {
    graphList <- lapply(graphList,
                        function(g)
                        {                      
                          nodeDataDefaults(g, "weight") <- defaultWeight
                          return(g)
                        })
    return(graphList)
  }  
  if(is.vector(weights))
  {
    graphList <- lapply(graphList,
                        function(g)
                        {
                          i <- nodes(g)[nodes(g) %in% names(weights)]
                          
                          nodeDataDefaults(g, "weight") <- defaultWeight
                          
                          if(length(i) != 0)
                            nodeData(g, i, "weight") <- weights[i]
                          
                          return(g)
                        })
    return(graphList)
  }
  if(is.matrix(weights))
  {
    graphList <- Recall(graphList, numeric(0), defaultWeight)
    
    
    
    gi <- names(graphList)[names(graphList) %in% colnames(weights)]
    
    if(length(gi) == 0)
      return(graphList)
    
    for(i in 1:length(gi))
    {
      
      w <- weights[,gi[i]]
      names(w) <- rownames(weights)
      
      
      g <- graphList[[gi[i]]]
      
      j <- nodes(g)[nodes(g) %in% names(w)]
      
      nodeDataDefaults(g, "weight") <- defaultWeight
      
      if(length(j) != 0)
        nodeData(g, j, "weight") <- w[j]
      
      graphList[gi[i]] <- g
    }  
    
    return(graphList)
  }
  return(NULL)
}


#' Set gene weights based on edge type
#' 
#' \code{setEdgeWeights}
#' 
#' @param graphList a list of \code{\link{graphNEL}} objects
#' @param edgeTypeAttr edge attribute to be considered as the edge type. If the edge has multiple types, 
#'                     the edge type attribute is considered as a comma separeted list of types
#' @param edgeWeightByType named list of weights, where the names of the list are the
#'                         edge type (values of the attribute defined by \code{edgeTypeAttr})
#' @param defaultWeight default value for an edge with a type not defined in \code{edgeWeightByType}
#' @param combineWeights for the edges with multiple types, the function to be applied on the vector of weights
#' @param nodeOnlyGraphs boolean value marking if graphs with no edges should be returned or not; note that graphs with all edge weights equal to 0 are considered node only graphs
#' 
#' @return
#' 
#' The \code{graphList} with the edge weights set.
#' 
#' @author
#' 
#' Calin Voichita and Sorin Draghici
#' 
#' @examples
#' 
#' # load the set of pathways
#' kpg <- keggPathwayGraphs("hsa")
#' 
#' kpg <- setEdgeWeights(kpg)
#' 
#' edgeWeights(kpg[["path:hsa04110"]])
#' 
#' @export
setEdgeWeights <- function(graphList,
                           edgeTypeAttr = "subtype",
                           edgeWeightByType = list(activation = 1, inhibition = -1, expression = 1, repression = -1),
                           defaultWeight = 0,
                           combineWeights = sum,
                           nodeOnlyGraphs = FALSE)
{
  graphList <- lapply(graphList,
                      function(g)
                      {
                        gftM <- graph2ftM(g)
                        
                        if(nrow(gftM) == 0)
                          return(g)
                        
                        weights <- sapply(strsplit(unlist(edgeData(g, gftM[,1], gftM[,2], edgeTypeAttr)), ","),
                                          function(x){
                                            weightNames <- names(edgeWeightByType)[match(x, names(edgeWeightByType))]
                                            weightNames <- weightNames[!is.na(weightNames)]
                                            
                                            if(length(weightNames) == 0)
                                              return(defaultWeight)
                                            
                                            return(combineWeights(unlist(edgeWeightByType[weightNames])))
                                          })
                        
                        suppressWarnings(g <- addEdge(gftM[,1], gftM[,2], g, weights))
                        
                        return(g)
                      })
  
  if (!nodeOnlyGraphs)
    return(graphList[sapply(graphList, function(x) length(unlist(edges(x)))) != 0])
  
  return(graphList)
}

test_setNodeWeights <- function()
{
  # load the set of pathways
  kpg <- keggPathwayGraphs("hsa")
  
  wt <- runif(length(nodes(kpg[["path:hsa04110"]])), 0, 1)
  names(wt) <- nodes(kpg[["path:hsa04110"]])
  
  kpg <- setNodeWeights(kpg, wt)
  
  checkEquals(nodeWeights(kpg[["path:hsa04110"]]), wt)
}

test_setEdgeWeights <- function()
{
  # load the set of pathways
  kpg <- keggPathwayGraphs("hsa")
  
  edgeWeightByType <- list(activation = 1, inhibition = -1, expression = 1, repression = -1)
  kpg <- setEdgeWeights(kpg)
  
  checkEquals(
    unlist(edgeWeights(kpg[["path:hsa04110"]], "hsa:7029")),
    unlist(edgeWeightByType[unlist(edgeData(kpg[["path:hsa04110"]], "hsa:7029", attr = "subtype"))]),
    checkNames = FALSE
  )
  
}

test_pe <- function()
{
  load(system.file("extdata/E-GEOD-21942.topTable.RData", package = "ROntoTools"))
  fc <- top$logFC[top$adj.P.Val <= .01]
  names(fc) <- top$entrez[top$adj.P.Val <= .01]
  pv <- top$P.Value[top$adj.P.Val <= .01]
  names(pv) <- top$entrez[top$adj.P.Val <= .01]
  ref <- top$entrez
  
  # load the set of pathways
  kpg <- keggPathwayGraphs("hsa")
  kpg <- setEdgeWeights(kpg)
  kpg <- setNodeWeights(kpg, weights = alphaMLG(pv), defaultWeight = 1)
  
  # perform the pathway analysis
  # in order to obtain accurate results the number of boostraps, nboot, should
  # be increase to a number like 2000
  peRes <- pe(fc, graphs = kpg, ref = ref, nboot = 100, verbose = TRUE)
  
  checkTrue(all(names(peRes@pathways) %in% names(kpg)))
  checkTrue(all(peRes@input %in% fc))
  checkTrue(all(peRes@ref %in% ref))
  checkEquals(peRes@cutOffFree, FALSE)
}

#' @keywords internal
addNames <- function(x, nms)
{
  if (length(x) == length(nms))
    names(x) <- nms
  
  x <- rep(x, length(nms))
  names(x) <- nms
  
  return(x)
}

#' @keywords internal
compute.bootPV <- function(real, dist)
  ( sum(abs(dist - mean(dist)) > abs(real - mean(dist))) + 1 ) / (1 + length(dist))

#' Combine independent p-values using the Fisher method
#' 
#' @param p a vector of independent p-values
#' @param eps the minimal p-value considered (all p-values smaller will be set to this value), default value 1e-24
#' 
#' @return the combined p-value
#' 
#' @author Calin Voichita and Sorin Draghici
#' 
#' @references
#' 
#' Tarca AL., Draghici S., Khatri P., Hassan SS., Kim J., Kim CJ., Kusanovic JP., Romero R.: "A Signaling Pathway Impact Analysis for Microarray Experiments", 2008, Bioinformatics, 2009, 25(1):75-82.
#' 
#' @seealso \code{\link{pe}},\code{\link{compute.normalInv}}
#' 
#' @examples
#' 
#' p <- c(.1, .01)
#' compute.fisher(p)
#' 
#' @export
compute.fisher <- function(p, eps = 1e-24) #default eps changed 2023-09-14 from 1e-6 to 1e-24
{
  stopifnot(any(p >= 0 & p<=1))  
  p[p < eps] <- eps
  
  k <- prod(p); 
  return(k-k*log(k))
}

#' Combine independent p-values using the normal inversion method
#' 
#' @param p a vector of independent p-values
#' @param eps the minimal p-value considered (all p-values smaller will be set to this value)
#' 
#' @return the combined p-value
#' 
#' @author Calin Voichita and Sorin Draghici
#' 
#' @references
#' 
#' Tarca AL., Draghici S., Romero R.: "A Mmore Specific Method To Combine Perturbation and Over-representation Evidence in Pathway Analysis", PSB 2010 poster.
#' 
#' @seealso \code{\link{pe}},\code{\link{compute.fisher}}
#' 
#' @examples
#' 
#' p <- c(.1, .01)
#' compute.normalInv(p)
#' 
#' @export
compute.normalInv <- function(p, eps = 1e-6)
{
  stopifnot(any(p >= 0 & p<=1))  
  p[p < eps] <- eps
  return(pnorm(sum(sapply(p, qnorm)) / sqrt(length(p))))
}

#` @keywords internal
graph2ftM <- function(g)
{
  ind <- which(as.vector(as(g, "matrix"))!=0)
  
  from <- (ind-1) %% length(nodes(g)) + 1
  to <- (ind-1) %/% length(nodes(g)) + 1
  
  return(cbind(nodes(g)[from], nodes(g)[to]))
}

#' Compute alpha weights
#' 
#' Transform a vector of p-values into weights.
#' 
#' @details
#' 
#' Computes a set of weights from p-values using the formula \code{1-pv/threshold}.
#' 
#' @param pv vector of p-values
#' @param threshold the threshold value that was used to select DE genes
#' 
#' @author
#' 
#' Calin Voichita and Sorin Draghici
#'
#' @seealso \code{\link{pe}}
#' 
#' @examples
#' 
#' load(system.file("extdata/E-GEOD-21942.topTable.RData", package = "ROntoTools"))
#' 
#' head(alpha1MR(top$adj.P.Val))
#' 
#' @export
alpha1MR <- function(pv, threshold = max(pv))
{
  if (!is.numeric(pv))
    stop("pv is not numeric")
  if (threshold == 0)
    stop("threshold cannot be 0")
  
  return(1-pv/threshold)
}


#' Compute alpha weights
#' 
#' Transform a vector of p-values into weights.
#' 
#' @details
#' 
#' Computes a set of weights from p-values using the formula \code{-log10(pv/threshold)}.
#' 
#' @param pv vector of p-values
#' @param threshold the threshold value that was used to select DE genes
#' 
#' @author
#' 
#' Calin Voichita and Sorin Draghici
#'
#' @seealso \code{\link{pe}}
#' 
#' @examples
#' 
#' load(system.file("extdata/E-GEOD-21942.topTable.RData", package = "ROntoTools"))
#' 
#' head(alphaMLG(top$adj.P.Val))
#' 
#' @export
alphaMLG <- function(pv, threshold = max(pv))
{
  if (!is.numeric(pv))
    stop("pv is not numeric")
  if (threshold == 0)
    stop("threshold cannot be 0")
  
  return(-log10(pv/threshold))
}

test_alpha1MR <- function()
{
  
  checkEquals(alpha1MR(.5), 0)
  
  c <- (1:10)/10
  
  checkEquals(alpha1MR(c), 1-c/max(c))
  
  checkException(alpha1MR("c"), "pv is not numeric")
  
}

test_alphaMLG <- function()
{
  
  checkEquals(alphaMLG(.5), 0)
  
  c <- (1:10)/10
  
  checkEquals(alphaMLG(c), -log10(c/max(c)))
  
  checkException(alphaMLG("c"), "pv is not numeric")
  
}

compute.ppDis <- function(pDisPath)
  ifelse( !all(pDisPath@boot$t[,"tpDis"] == 0),
          compute.bootPV(pDisPath@boot$t0["tpDis"], pDisPath@boot$t[,"tpDis"]),
          NA)


compute.pORA <- function(pDisPath, inputSize, refSize)
  phyper(q = length(pDisPath@input)-1,
         m = length(pDisPath@ref),
         n = refSize-length(pDisPath@ref),
         k = inputSize,
         lower.tail = FALSE) 


get.totalpDis <- function(pDisPath)
  as.numeric(pDisPath@boot$t0["tpDis"])

get.totalpDisNorm <- function(pDisPath)
  ifelse( !all(pDisPath@boot$t[,"tpDis"] == 0),
          as.numeric((pDisPath@boot$t0["tpDis"] - mean(pDisPath@boot$t[,"tpDis"])) / sd(pDisPath@boot$t[,"tpDis"])),
          NA)

#' Pathway-Express result class
#' 
#' This class is used to encode the results of the pathway analysis performed by the function \code{\link{pe}}.
#' 
#' @details
#' 
#' The slots \code{input} and \code{ref} record global information related to the whole analysis, 
#' while the \code{pathways} slot records the specific results as \code{\link{pePathway-class}} for each one of the pathways used in the analysis.
#' 
#' 
#' @section Slots: 
#' 
#' \describe{
#'     \item{\code{pathways}:}{A list of \code{\link{pePathway-class}} objects.}
#'     \item{\code{input}:}{named vector of fold changes used for the analysis. The names of the vector are the IDs originaly used.}
#'     \item{\code{ref}:}{character vector containing the IDs used as reference in the analysis.}
#'     \item{\code{cutOffFree}:}{boolean value indicating if a cut-of-free analysis has been performed.}
#'   }
#' 
#' @author
#' 
#' Calin Voichita and Sorin Draghici
#'
#' @seealso \code{\link{pe}}, \code{\link{pePathway-class}}
#'
#' @exportClass peRes
setClass("peRes",
         representation(pathways = "list",
                        input = "numeric",
                        ref = "character",
                        cutOffFree = "logical"),
         prototype(pathways = list(), cutOffFree = FALSE)
)

#' Class that encodes the result of Pathway-Express for a single pathway
#' 
#' 
#' @section Slots:
#' 
#' \describe{
#'    \item{\code{map}:}{an object of type graph (e.g., \code{\link{graphNEL}}).}
#'    \item{\code{input}:}{named vector of fold changes for genes on this pathway. The names of the genes are the orignal IDS used in the analysis}
#'    \item{\code{ref}:}{vector of reference IDs on this pathway}
#'    \item{\code{boot}:}{an object of class \code{boot} encoding the bootstrap information.}
#'    \item{\code{Pert}:}{the gene perturbation factors for all genes on the pathway, as computed by Pathway-Express.}
#'    \item{\code{Acc}:}{the gene accumulations for all genes on the pathway, as computed by Pathway-Express.}
#'    \item{\code{asGS}:}{pathway was considered as gene set}
#' }
#' 
#' @author
#' 
#' Calin Voichita and Sorin Draghici
#'
#'             
#' @seealso \code{\link{pe}}, \code{\link{peRes-class}}
#' 
#' @aliases pePathway-class
#' @import graph
#' @exportClass pePathway
setClass("pePathway", 
         representation(map = "graph",
                        input = "numeric",
                        ref = "character",
                        boot = "ANY",
                        Pert = "numeric",
                        Acc = "numeric",
                        asGS = "logical"
         ), 
         prototype(map = new("graphNEL")
         )
)


#' Primary dis-regulation (pDis) result class
#' 
#' This class is used to encode the results of the pathway analysis performed by the function \code{\link{pDis}}.
#' 
#' @details
#' 
#' The slots \code{input} and \code{ref} record global information related to the whole analysis, 
#' while the \code{pathways} slot records the specific results as \code{\link{pDisPathway-class}} for each one of the pathways used in the analysis.
#' 
#' 
#' @section Slots: 
#' 
#' \describe{
#'     \item{\code{pathways}:}{A list of \code{\link{pDisPathway-class}} objects.}
#'     \item{\code{input}:}{named vector of fold changes used for the analysis. The names of the vector are the IDs originaly used.}
#'     \item{\code{ref}:}{character vector containing the IDs used as reference in the analysis.}
#'     \item{\code{cutOffFree}:}{boolean value indicating if a cut-of-free analysis has been performed.}
#'   }
#' 
#' @author
#' 
#' Calin Voichita, Sahar Ansari and Sorin Draghici
#'
#' @seealso \code{\link{pDis}}, \code{\link{pDisPathway-class}}
#'
#' @aliases pDisRes-class
#' @exportClass pDisRes
setClass("pDisRes",
         representation(pathways = "list",
                        input = "numeric",
                        ref = "character",
                        cutOffFree = "logical"),
         prototype(pathways = list(), cutOffFree = FALSE)
)

#' Class that encodes the result of pDis analysis for a single pathway
#' 
#' 
#' @section Slots:
#' 
#' \describe{
#'    \item{\code{map}:}{an object of type graph (e.g., \code{\link{graphNEL}}).}
#'    \item{\code{input}:}{named vector of fold changes for genes on this pathway. The names of the genes are the orignal IDS used in the analysis}
#'    \item{\code{ref}:}{vector of reference IDs on this pathway}
#'    \item{\code{boot}:}{an object of class \code{boot} encoding the bootstrap information.}
#'    \item{\code{pDis}:}{the gene primary dis-regulation for all genes on the pathway, as computed by primary dis-regulation.}
#'    \item{\code{asGS}:}{pathway was considered as gene set}
#' }
#' 
#' @author
#' 
#' Calin Voichita, Sahar Ansari and Sorin Draghici
#'
#'             
#' @seealso \code{\link{pDis}}, \code{\link{pDisRes-class}}
#' 
#' @aliases pDisPathway-class
#' @import graph
#' @exportClass pDisPathway
setClass("pDisPathway", 
         representation(map = "graph",
                        input = "numeric",
                        ref = "character",
                        boot = "ANY",
                        pDis = "numeric",
                        asGS = "logical"
         ), 
         prototype(map = new("graphNEL")
         )
)

#' Primary dis-regulation: Pathway analysis approach based on the unexplained dis-regulation of genes 
#' 
#' 
#' @param x named vector of log fold changes for the differentially expressed genes; \code{names(x)} must use the same id's as \code{ref} and the nodes of the \code{graphs}
#' @param graphs list of pathway graphs as objects of type \code{graph} (e.g., \code{\link{graphNEL}}); the graphs must be weighted graphs (i.e., have an attribute \code{weight} for both nodes and edges)
#' @param ref the reference vector for all genes in the analysis; if the reference is not provided or it is identical to \code{names(x)} a cut-off free analysis is performed
#' @param nboot number of bootstrap iterations
#' @param verbose print progress output
#' @param cluster a cluster object created by makeCluster for parallel computations
#' @param seed an integer value passed to set.seed() during the boostrap permutations
#' 
#' @details
#' 
#' See details in the cited articles.
#' 
#' @return
#' 
#' An object of class \code{\link{pDisRes-class}}.
#' 
#' @author
#' 
#' Calin Voichita, Sahar Ansari and Sorin Draghici
#' 
#' @references
#' 
#' Voichita C., Donato M., Draghici S.: "Incorporating gene significance in the impact analysis of signaling pathways", IEEE Machine Learning and Applications (ICMLA), 2012 11th International Conference on, Vol. 1, p.126-131, 2012
#' Ansari, S., Voichita, C., Donato, M., Tagett, R., & Draghici, S. A Novel Pathway Analysis Approach Based on the Unexplained Disregulation of Genes.
#' 
#' 
#' @seealso \code{\link{Summary}}, 
#' \code{\link{keggPathwayGraphs}}, \code{\link{setNodeWeights}}, \code{\link{setEdgeWeights}}
#' 
#' @examples
#' 
#' # load a multiple sclerosis study (public data available in Array Express 
#' # ID: E-GEOD-21942)
#' # This file contains the top table, produced by the limma package with 
#' # added gene information. All the probe sets with no gene associate to them,
#' # have been removed. Only the most significant probe set for each gene has been
#' # kept (the table is already ordered by p-value)
#' # The table contains the expression fold change and signficance of each  
#' # probe set in peripheral blood mononuclear cells (PBMC) from 12 MS patients
#' # and 15 controls.
#' load(system.file("extdata/E-GEOD-21942.topTable.RData", package = "ROntoTools"))
#' head(top)
#' 
#' # select differentially expressed genes at 1% and save their fold change in a 
#' # vector fc and their p-values in a vector pv
#' fc <- top$logFC[top$adj.P.Val <= .01]
#' names(fc) <- top$entrez[top$adj.P.Val <= .01]
#' 
#' pv <- top$P.Value[top$adj.P.Val <= .01]
#' names(pv) <- top$entrez[top$adj.P.Val <= .01]
#' 
#' # alternativly use all the genes for the analysis
#' # NOT RUN: 
#' # fc <- top$logFC
#' # names(fc) <- top$entrez
#' 
#' # pv <- top$P.Value
#' # names(pv) <- top$entrez
#' 
#' # get the reference
#' ref <- top$entrez
#' 
#' # load the set of pathways
#' kpg <- keggPathwayGraphs("hsa")
#' 
#' # set the beta information (see the citated documents for meaning of beta)
#' kpg <- setEdgeWeights(kpg)
#' 
#' # inlcude the significance information in the analysis (see Voichita:2012 
#' # for more information)
#' # set the alpha information based on the pv with one of the predefined methods
#' kpg <- setNodeWeights(kpg, weights = alphaMLG(pv), defaultWeight = 1)
#' 
#' # perform the pathway analysis
#' # in order to obtain accurate results the number of boostraps, nboot, should 
#' # be increase to a number like 2000
#' pDisRes <- pDis(fc, graphs = kpg, ref = ref, nboot = 100, verbose = TRUE)
#' 
#' # obtain summary of results
#' head(Summary(pDisRes))
#' 
#' @export
pDis <- function(x, graphs, ref = NULL, nboot = 2000, verbose = TRUE, cluster = NULL, seed = NULL)
{
  cutOffFree <- FALSE
  if (is.null(ref))
  {
    ref <- names(x)
    cutOffFree <- TRUE
  }
  else
  {
    if (!any(is.na(match(ref,names(x)))))
    {
      warning("All the reference IDs are part of the input. Cut-off free analysis is performed.") 
      ref <- names(x)
      cutOffFree <- TRUE
    }
  }
  
  preservedSeed <- NULL
  if (exists(".Random.seed"))
    preservedSeed <- .Random.seed
  
  if(!is.null(seed))
    set.seed(seed)
  
  if (any(is.na(match(names(x), ref))))
  {
    warning("There are input IDs not available in the reference. These will be excluded from analysis.")
    x <- x[!is.na(match(names(x), ref))]
  }
  
  pDisRes <- pDis.helper(x = x, ref = ref, graphs = graphs, nboot = nboot, verbose = verbose, cluster = cluster, seed = seed)
  pDisRes@cutOffFree <- cutOffFree
  
  if(is.null(preservedSeed))
  {
    if(!is.null(seed))
      rm(.Random.seed)
  }
  else
    .Random.seed <- preservedSeed
  
  return(pDisRes)
}

#' @import parallel
pDis.helper <- function(x, graphs, ref = NULL, nboot = 2000, verbose = TRUE, cluster = NULL, seed = NULL)
{
  if(verbose)
  {
    message("Performing pathway analysis...")
    if(is.null(cluster))
    {
      pb <- txtProgressBar(min = 0, max = length(graphs), style = 3)  
    }
  }
  
  t1 <- Sys.time()
  if (is.null(cluster))
  {
    allBoot <- lapply(graphs, function(g, seed) {
      if(!is.null(seed))
        set.seed(seed)
      ret <- pDis.boot(g, x = x, ref = ref, nboot = nboot)
      if(verbose)
        setTxtProgressBar(pb, getTxtProgressBar(pb) + 1)
      return(ret)
    }, seed = seed)
  }
  else
  {
    clusterExport(cluster, c("pDis.boot", "compute.inverse", "compute.B_pDis"))
    clusterEvalQ(cluster, library(ROntoTools))
    
    allBoot <- parLapply(cluster, graphs, function(g, seed) {
      if(!is.null(seed))
        set.seed(seed)
      ret <- pDis.boot(g, x = x, ref = ref, nboot = nboot)
      return(ret)
    }, seed = seed)
    
  }
  t2 <- Sys.time()
  
  if(verbose)
  {
    message("Analysis completed in ", format(t2-t1), ".")
  }
  
  allBoot <- allBoot[!sapply(allBoot, is.null)]
  
  pDisRes <- new("pDisRes", pathways = allBoot, input = x, ref = ref)
  
  return(pDisRes)
}

#' @import boot
#' @keywords internal
pDis.boot <- function(g, x, ref, nboot, all.genes = F)
{
  inv <- (compute.B_pDis(g))
  
  pDisPath <- new("pDisPathway", 
                map = g, 
                input = x[names(x) %in% nodes(g)],
                ref = ref[ref %in% nodes(g)])
  
  if (length(pDisPath@input) == 0)
    return(NULL)
  
  if (is.null(inv))
  {
    pDisPath@asGS <- TRUE
    return(pDisPath)
  }
  
  # same number of DE genes at any position in the pathway 
  # (given by the gene from the pathway in the reference)
  ran.gen.de <- function(x, l)  {
    y <- sample(l$fc, length(x))
    names(y) <- sample(l$ref, length(x))
    return(y)
  }
  
  pDisPath@boot <- boot(pDisPath@input, 
                      function(x, inv) {
                        xx <- rep(0, nrow(inv));  names(xx) <- rownames(inv);
                        xx[names(x)] <- x
                        xx <- xx * nodeWeights(pDisPath@map, names(xx))
                        tt = inv %*% xx;
                        ret <- c(sum(abs(tt)))
                        names(ret) <- c("tpDis")
                        return(ret)
                      }, 
                      nboot,
                      "parametric", ran.gen = ran.gen.de, mle = list(ref = pDisPath@ref, fc = as.numeric(x)),
                      inv = inv
  )
  colnames(pDisPath@boot$t) <- names(pDisPath@boot$t0)
  
  xx <- rep(0, nrow(inv))
  names(xx) <- rownames(inv)
  xx[names(pDisPath@input)] <- pDisPath@input  
  pDisPath@pDis = (inv %*% xx)[,1];
  pDisPath@asGS <- FALSE
  
  return(pDisPath) 
}


compute.B_pDis <- function(g, non.zero = TRUE)
{
  if (non.zero)
    # number of downstream genes (like in SPIA)
    nds <- sapply(edgeWeights(g), function(x) sum(x != 0 ))
  else
    nds <- sapply(edges(g), length)
  
  # add 1 for all genes that do not have downstream genes to avoid division by 0
  # this does not affect the computation
  nds[nds == 0] <- 1
  
  # compute B = (I - beta/nds)
  #B <- t(diag(length(nodes(g))) - as(g, "matrix") / nds)
  #
  B <- diag(length(nodes(g))) - t(as(g, "matrix")) / matrix(nds, byrow=TRUE, nrow = length(nds), ncol = length(nds))
   return(B)
}
 

#' Plot pathway level statistics
#' 
#' @description Display graphical representation of pathway level statistic like:
#' i) two way comparison between the measured expression change and one of the 
#' factors computed by Pathway-Express (\code{\link{pe}}) or ii) the boostrap 
#' statistics of the same factors.
#' 
#' 
#' @param x an object of type \code{\link{pePathway-class}}
#' @param y if provided, the factor to be ploted (either \code{Acc} (default) or \code{Pert}; see \code{\link{pePathway-class}})
#' @param main title
#' @param ... Arguments to be passed to methods, such as \code{\link{par}}
#' @param type type of plot (either \code{two.way} (default) or \code{boot})
#' @param eps any value smaller than this will be ploted as 0
#' 
#' @author Calin Voichita and Sorin Draghici
#' 
#' @seealso \code{\link{pe}}, \code{\link{plot,peRes,missing-method}}, \code{\link{peNodeRenderInfo}}, \code{\link{peEdgeRenderInfo}}
#' 
#' @examples
#' 
#' # load experiment
#' load(system.file("extdata/E-GEOD-21942.topTable.RData", package = "ROntoTools"))
#' fc <- top$logFC[top$adj.P.Val <= .01]
#' names(fc) <- top$entrez[top$adj.P.Val <= .01]
#' ref <- top$entrez
#' 
#' # load the set of pathways
#' kpg <- keggPathwayGraphs("hsa")
#' kpg <- setEdgeWeights(kpg)
#' kpg <- setNodeWeights(kpg, defaultWeight = 1)
#' 
#' # perform the pathway analysis (for more accurate results use nboot = 2000)
#' peRes <- pe(fc, graphs = kpg, ref = ref, nboot = 100, verbose = TRUE)
#' 
#' plot(peRes@@pathways[[50]])
#' 
#' plot(peRes@@pathways[[50]], "Pert", main = "Perturbation factor")
#' 
#' plot(peRes@@pathways[[50]], type = "boot")
#' 
#' plot(peRes@@pathways[[50]], "Pert", type = "boot", main = "Perturbation factor")
#' 
#' @rdname plot.pePathway-methods
#' 
#' @export
setMethod("plot", signature(x="pePathway", y="missing"),
          function(x, y, ..., type = "two.way", eps = 1e-6)
          {
            plot(x, y = "Acc", ..., type = type, eps = eps)           
          }
)

#' @rdname plot.pePathway-methods
#' 
#' @export
setMethod("plot", signature(x="pePathway", y="character"),
          function(x, y, main = "", ... , type = "two.way", eps = 1e-6)
          {
            if (!(y %in% c("Acc", "Pert")))
              stop("Undefined slot selected: ", y,".")
                        
            switch(type,
                   two.way={        
                     iy <- y
                     
                     extInput <- rep(0, length(slot(x, iy)))
                     names(extInput) <- names(slot(x, iy))
                     extInput[names(x@input)] <- x@input
                     
                     cl <- rep("black", length(slot(x, iy)))
                     cl[abs(slot(x, iy)) >= eps] <- "green"
                     cl[abs(extInput) >= eps] <- "blue"
                     cl[abs(slot(x, iy)) >= eps & abs(extInput) >= eps] <- "red"
                     
                     plot(slot(x, iy), extInput, pch = 16, xlab = y, ylab = "Log2 FC", main = main, ...)
                     abline(v=0,h=0, lwd = .5)
                     points(slot(x, iy), extInput, pch = 16, col = cl)
                     
                     return(invisible())
                   },
                   boot={
                     iy <- paste("t", y, sep = "")
                     
                     tB <- x@boot$t0[iy]
                     allB <- x@boot$t[,iy]
                     
                     tB <- (tB - mean(allB)) / sd(allB)
                     allB <- (allB - mean(allB)) / sd(allB)
                     
                     xlim <- c(min(allB, tB), max(allB, tB)) * 1.10
                     
                     plot(density(allB, from = xlim[1], to = xlim[2]), xlab = y, main = main, ...)
                     abline(v=0, lwd = .5)
                     abline(v=tB, lwd = 1, col = "red")
                     
                     return(invisible())
                   }
            )
            stop(type, " is not a valid plot type.")
            
          }
)

#' Plot Pathway-Express result
#' 
#' @description Display a two-way plot using two of the p-values from the Pathway-Express analysis.
#' 
#' @param x an object of type \code{\link{peRes-class}}
#' @param y vector of two p-values names to be combined using \code{comb.pv.func} (default: \code{c("pAcc", "pORA")}).
#' @param ... Arguments to be passed to methods, such as \code{\link{par}}.
#' @param comb.pv.func the function to combine the p-values - takes as input a vector of p-values 
#' and returns the combined p-value (default: \code{\link{compute.fisher}}).
#' @param adjust.method the name of the method to adjust the p-value (see \code{\link{p.adjust}})
#' @param threshold corrected p-value threshold
#' @param eps any value smaller than this will be considered as \code{eps} (default: \code{1e-6}).
#' 
#' @author Calin Voichita and Sorin Draghici
#' 
#' @seealso \code{\link{pe}}, \code{\link{summary.peRes}}, \code{\link{plot,pePathway,missing-method}}
#' 
#' @examples
#' 
#' # load experiment
#' load(system.file("extdata/E-GEOD-21942.topTable.RData", package = "ROntoTools"))
#' fc <- top$logFC[top$adj.P.Val <= .01]
#' names(fc) <- top$entrez[top$adj.P.Val <= .01]
#' ref <- top$entrez
#' 
#' # load the set of pathways
#' kpg <- keggPathwayGraphs("hsa")
#' kpg <- setEdgeWeights(kpg)
#' kpg <- setNodeWeights(kpg, defaultWeight = 1)
#' 
#' # perform the pathway analysis (for more accurate results use nboot = 2000)
#' peRes <- pe(fc, graphs = kpg, ref = ref, nboot = 100, verbose = TRUE)
#' 
#' plot(peRes)
#' 
#' plot(peRes, c("pPert","pORA"), comb.pv.func = compute.normalInv, threshold = .01)
#' 
#' @rdname plot.peRes-methods
#' 
#' @export
setMethod("plot", signature(x="peRes", y="missing"),
          function(x, y, ... , comb.pv.func = compute.fisher, adjust.method = "fdr", threshold = .05, eps = 1e-6)
          {
            plot(x, y = c("pAcc", "pORA"), ... , comb.pv.func = comb.pv.func, adjust.method = adjust.method,
                 threshold = threshold, eps = eps)
          }
)

#' @rdname plot.peRes-methods
#'
#' @export
setMethod("plot", signature(x="peRes", y="character"),
          function(x, y, ... , comb.pv.func = compute.fisher, adjust.method = "fdr", threshold = .05, eps = 1e-6)
          {
            
            st <- Summary(x, comb.pv = y, comb.pv.func = comb.pv.func, adjust.method = adjust.method)
            st <- st[!is.na(st[, paste("pComb", adjust.method, sep = ".")]),]
            
            st[,y[1]][st[,y[1]] <= eps] <- eps
            st[,y[2]][st[,y[2]] <= eps] <- eps
            
            i <- st[, paste("pComb", adjust.method, sep = ".")] <= threshold
            thr.comb <- mean(min(st[!i,"pComb"]),max(st[i,"pComb"]))
            
            xrange <- c(min(-log(st[,y[1]])), max(-log(st[,y[1]])))
            xrange[2] <- xrange[2] + (xrange[2]-xrange[1]) * .1
            yrange <- c(min(-log(st[,y[2]])), max(-log(st[,y[2]]))) 
            yrange[2] <- yrange[2] + (yrange[2]-yrange[1]) * .1
            
            i <- seq(xrange[1], xrange[2], length.out=200)
            j <- seq(yrange[1], yrange[2], length.out=200)
            expGrid <- expand.grid(i,j)
            z <- apply(1/exp(expGrid), 1, comb.pv.func) <= thr.comb
            
            plot(c(min(-log(st[,y[1]])),min(-log(st[,y[2]]))), 
                 xlab = y[1], ylab = y[2], 
                 xlim = xrange,
                 ylim = yrange,
                 col = "white", ...)
            nonSig <- expGrid[!z,][chull(expGrid[!z,]),]
            sig <- expGrid[z,][chull(expGrid[z,]),]
            
            polygon(nonSig, col="gray90")
            polygon(sig, col="lightcyan")
            
            i <- st[, paste("pComb", adjust.method, sep = ".")] <= threshold
            
            points(-log(st[,y[1]]), -log(st[,y[2]]),  xlab = y[1], ylab = y[2], pch = 19)
            if (any(i))
            {
              points(-log(st[,y[1]])[i], -log(st[,y[2]])[i], pch = 21, bg = "red")
              text(-log(st[,y[1]])[i], -log(st[,y[2]])[i] - .5, labels = rownames(st)[i], 
                   cex = .75)
            }
            
            i <- st[, paste(y[1], adjust.method, sep = ".")] <= threshold
            if (any(i))
            {              
              thr1 <- mean(min(st[!i,y[1]]),max(st[i,y[1]]))            
              abline(v = -log(thr1), col = "red", lwd = 2, lty = 2)
            }
            
            i <- st[, paste(y[2], adjust.method, sep = ".")] <= threshold
            if (any(i))
            {
              thr2 <- mean(min(st[!i,y[2]]),max(st[i,y[2]]))                        
              abline(h = -log(thr2), col = "red", lwd = 2, lty = 2)
            }
          }
)

compute.pAcc <- function(pePath)
  ifelse( !all(pePath@boot$t[,"tAcc"] == 0),
    compute.bootPV(pePath@boot$t0["tAcc"], pePath@boot$t[,"tAcc"]),
          NA)

compute.pPert <- function(pePath)
  ifelse( !all(pePath@boot$t[,"tPert"] == 0),
          compute.bootPV(pePath@boot$t0["tPert"], pePath@boot$t[,"tPert"]),
          NA)


compute.pORA <- function(pePath, inputSize, refSize)
  phyper(q = length(pePath@input)-1,
         m = length(pePath@ref),
         n = refSize-length(pePath@ref),
         k = inputSize,
         lower.tail = FALSE) 

get.totalAcc <- function(pePath)
  as.numeric(pePath@boot$t0["tAcc"])

get.totalAccNorm <- function(pePath)
  ifelse( !all(pePath@boot$t[,"tAcc"] == 0),
          as.numeric((pePath@boot$t0["tAcc"] - mean(pePath@boot$t[,"tAcc"])) / sd(pePath@boot$t[,"tAcc"])),
          NA)

get.totalPert <- function(pePath)
  as.numeric(pePath@boot$t0["tPert"])

get.totalPertNorm <- function(pePath)
  ifelse( !all(pePath@boot$t[,"tPert"] == 0),
          as.numeric((pePath@boot$t0["tPert"] - mean(pePath@boot$t[,"tPert"])) / sd(pePath@boot$t[,"tPert"])),
          NA)

#' @rdname nodeWeights
#' @aliases nodeWeights,graph,character-method
#' @import graph
#' @export
setMethod("nodeWeights", signature(object="graph", index="character"),
          function (object, index, attr, default) 
          {
            if (!is.character(attr) || length(attr) != 1) 
              stop("'attr' must be character(1)")
            if (!attr %in% names(nodeDataDefaults(object))) {
              nodeDataDefaults(object, attr) <- default
            }
            nw <- nodeData(object, index, attr = attr)
            if (length(nw) != 0) 
              return(unlist(nw))
            else
              return(numeric(0))
          }
)

#' @rdname nodeWeights
#' @aliases nodeWeights,graph,numeric-method
#' @import graph
#' @export
setMethod("nodeWeights", signature(object="graph", index="numeric"),
          function (object, index, attr, default) 
          {
            index <- nodes(object)[index]
            nodeWeights(object, index, attr = attr, default = default)
          })

#' @rdname nodeWeights
#' @aliases nodeWeights,graph,missing-method
#' @import graph
#' @export
setMethod("nodeWeights", signature(object="graph", index="missing"),
          function (object, index, attr, default) 
          {
            index <- nodes(object)
            nodeWeights(object, index, attr = attr, default = default)
          })

#' Retrieve the node weights of a graph
#' 
#' @description
#' 
#' A generic function that returns the node weights of a graph. If \code{index} is specified, only the weights of the specified nodes are returned. The user can control which node attribute is interpreted as the weight.
#' 
#' @param object A graph, any object that inherits the \code{graph} class.
#' @param index If supplied, a character or numeric vector of node names or indices.
#' @param ... Unused.
#' @param attr The name of the node attribute to use as a weight. You can view the list of defined node attributes and their default values using nodeDataDefaults.
#' @param default The value to use if \code{object} has no node attribute named by the value of \code{attr}. The default is the value 1.
#' 
#' @details
#' 
#' The weights of all nodes identified by the \code{index} are returned. If \code{index} is not supplied, the weights of all nodes are returned.
#' 
#' By default, \code{nodeWeights} looks for an node attribute with name "weight" and, if found, uses these values to construct the node weight vector.
#' You can make use of attributes stored under a different name by providing a value for the \code{attr} argument.
#' For example, if \code{object} is a graph instance with an node attribute named "WTS", then the call \code{nodeWeights(object, attr="WTS")} will attempt to use those values.
#' 
#' If the graph instance does not have an node attribute with name given by the value of the \code{attr} argument, \code{default} will be used as the weight for all nodes.
#' Note that if there is an attribute named by \code{attr}, then its default value will be used for nodes not specifically customized.
#' See nodeData and nodeDataDefaults for more information.
#' 
#' @return
#' 
#' A named vector with the node weights. The names of the vector are the names of the specified \code{index}, or all nodes if \code{index} was not provided.
#' 
#' @author
#' 
#' Calin Voichita and Sorin Draghici
#' 
#' @seealso
#' 
#' \link{nodes}, \link{nodeData}
#' 
#' @examples
#' 
#' library(graph)
#' V <- LETTERS[1:4]
#' g <- graphNEL(nodes = V, edgemode = "directed")
#' nodeWeights(g)
#' nodeWeights(g, "B")
#' nodeWeights(g, attr = "WT", default = 3)
#' 
#' @rdname nodeWeights
#' 
#' @export
setGeneric("nodeWeights",
           function(object, index, ..., attr="weight", default=1)
             standardGeneric("nodeWeights")
)

#' @import KEGGREST
#' @import KEGGgraph
loadKEGGpathwayDataREST <- function(organism = "hsa",
                                    updateCache = FALSE,
                                    verbose = TRUE)
{ 
  dfUnparsed <- paste(system.file("extdata",package="ROntoTools"),
                      "/KEGGRESTunparsed_",organism,".RData", sep = "") 
  
  if (!file.exists(dfUnparsed) || updateCache)
  {
    pathList <- keggList("pathway", organism)
   
    if (verbose)
    {
      message("Downloading pathway data:")
      pb <- txtProgressBar(min = 0, max = length(pathList)-1, style = 3)
    }
    
    tmpDir <- tempfile("ROntoTools", tempdir())
    dir.create(tmpDir)
    
    
    allPathwayInfo <- lapply(names(pathList), 
                             function(pathID) {
                               p <- keggGet(pathID, "kgml")
                               pKgml <- file.path(tmpDir, paste(strsplit(pathID, ":")[[1]][2], ".kgml", sep = ""))
                               write(p, pKgml)
                               pathData <- parseKGML(pKgml)
                               file.remove(pKgml)
                               if(verbose)
                                 setTxtProgressBar(pb, getTxtProgressBar(pb) + 1)
                               return(pathData)
                             })
    dbInfo <- keggInfo("pathway")
    
    file.remove(tmpDir)
    
    save(allPathwayInfo, dbInfo, file = dfUnparsed)
  }else{    
    load(dfUnparsed)
    message(paste("Using cached pathway data. Database info:\n", dbInfo, sep =""))
  }
  
  return(allPathwayInfo)
}


#' Download and parse KEGG pathway data
#' 
#' @param organism organism code as defined by KEGG
#' @param targRelTypes target relation types
#' @param relPercThresh percentage of the number of relation types over all possible realtions in the pathway
#' @param nodeOnlyGraphs allow graphs with no edges
#' @param updateCache re-download KEGG data
#' @param verbose show progress of downloading and parsing
#' 
#' @return
#' 
#' A list of \code{\link{graphNEL}} objects encoding the pathway information.
#' 
#' @author
#' 
#' Calin Voichita and Sorin Draghici
#' 
#' @seealso \code{\link{keggPathwayNames}}
#' 
#' @examples
#'
#' # The pathway cache provided as part of the pathway contains only the 
#' # pathways that passed the default filtering. We recommend, re-downloading
#' # the pathways using the updateCache parameter
#' kpg <- keggPathwayGraphs("hsa")
#' 
#' # to update the pathway cache for human run:
#' # kpg <- keggPathwayGraphs("hsa", updateCache = TRUE)
#' # this is time consuming and depends on the available bandwith.
#' 
#' head(names(kpg))
#' 
#' kpg[["path:hsa04110"]]
#' head(nodes(kpg[["path:hsa04110"]]))
#' head(edges(kpg[["path:hsa04110"]]))
#' 
#' @export
keggPathwayGraphs <- function(organism = "hsa", 
                              targRelTypes = c("GErel","PCrel","PPrel"),
                              relPercThresh = 0.9,
                              nodeOnlyGraphs = FALSE,
                              updateCache = FALSE,
                              verbose = TRUE)
{
  defaultParameters <- FALSE
  if ((organism == "hsa") & all(targRelTypes %in% c("GErel","PCrel","PPrel")) &
        (relPercThresh == 0.9) & (nodeOnlyGraphs == FALSE))
    defaultParameters <- TRUE  
  
  allPathwayInfo <- loadKEGGpathwayDataREST(organism, updateCache, verbose)
  
  if (defaultParameters & !updateCache)
  {
    message("Default parameters detected. Using pre-parsed data.")
    load(paste(system.file("extdata",package="ROntoTools"), "/kpgDefault.RData", sep = ""))
    return(pathwayGraphs)
  }
  
  l <- lapply(allPathwayInfo, function(path) {
    l <- sapply(edges(path), getType)
    if(length(l) == 0)
      return(0)
    t <- table(l)
    return(t)
  })
  
  allRelTypes <- unique(unlist(lapply(l, names)))
  
  counts <- do.call(rbind,lapply(l, function(x) as.vector(x[allRelTypes])))
  colnames(counts) <- allRelTypes
  
  counts[is.na(counts)] <- 0
  
  accIndex <- rowSums(counts[,targRelTypes], na.rm=T) / rowSums(counts, na.rm=T) >= relPercThresh
  accIndex[is.na(accIndex)] <- nodeOnlyGraphs
  allPathwayInfo <- allPathwayInfo[accIndex]
  
  names(allPathwayInfo) <- sapply(allPathwayInfo, getName)
  
  if (verbose)
  {
    message("Parsing pathway data:")
    pb <- txtProgressBar(min = 0, max = length(allPathwayInfo)-1, style = 3)
  }
  
  pathwayGraphs <- lapply(allPathwayInfo, function(g) 
  {
    
#     tryCatch(
      g <- KEGGpathway2Graph(g, expandGenes=TRUE)
#       , error = function(e) {})    
    if (class(g) != "graphNEL") {
      return(NULL)
    }
    
    kg <- new("graphNEL", nodes(g), edges(g), edgemode = "directed")

    if (length(getKEGGedgeData(g)) == 0)
    {
      if (verbose)
        setTxtProgressBar(pb, getTxtProgressBar(pb) + 1)
      if (nodeOnlyGraphs)
        return(kg)
      else
        return(NULL)
    }
    edgeDataDefaults(kg, "subtype") <- NA
    

    cf <- cbind(
      do.call(rbind, strsplit(names(getKEGGedgeData(g)), '~')),
      sapply(getKEGGedgeData(g), function(e) 
        paste(lapply(getSubtype(e), getName), collapse=","))
    );

    if (nrow(cf) < 2) {
      ucf <- cf
    } else {
      ucf <- cf[unique(rownames(cf)),]
      ucf[,3] <- tapply(cf[,3], rownames(cf), function(ll) return(paste( unique(ll), collapse = ',')))[rownames(ucf)]
    }
    

    relGeneTable <- data.frame(ucf, stringsAsFactors = FALSE)
    names(relGeneTable) <- c("from","to","subtype")

    edgeData(kg, relGeneTable$from, relGeneTable$to, "subtype") <- relGeneTable$subtype

    if (verbose)
      setTxtProgressBar(pb, getTxtProgressBar(pb) + 1)
    
    return(kg)
  })

  pathwayGraphs <- pathwayGraphs[!sapply(pathwayGraphs, is.null)]
  
  if (defaultParameters)
    save(pathwayGraphs, file = paste(system.file("extdata",package="ROntoTools"), "/kpgDefault.RData", sep = ""))
  
  return(pathwayGraphs)
}

#' Obtain KEGG pathway titles
#' 
#' @param organism organism code as defined by KEGG
#' @param updateCache re-download KEGG data
#' @param verbose show progress of downloading and parsing
#' 
#' @return
#' 
#' A named vector of pathway titles. The names of the vector are the pathway KEGG IDs.
#' 
#' @author
#' 
#' Calin Voichita and Sorin Draghici
#' 
#' @seealso \code{\link{keggPathwayGraphs}}
#' 
#' @examples
#'
#' kpn <- keggPathwayNames("hsa")
#' 
#' # to update the pathway cache for human run:
#' # kpn <- keggPathwayNames("hsa", updateCache = TRUE)
#' # this is time consuming and depends on the available bandwidth.
#' 
#' head(kpn)
#' 
#' @import KEGGgraph
#' @export
keggPathwayNames <- function(organism = "hsa", 
                              updateCache = FALSE,
                              verbose = TRUE)
{
  allPathwayInfo <- loadKEGGpathwayDataREST(organism, updateCache, verbose)
  
  allNames <- sapply(allPathwayInfo, getTitle)
  
  names(allNames) <- sapply(allPathwayInfo, getName)
  
  return(allNames)
}

#' Modified version of the same function from KEGGgraph
#' 
#' @keywords internal
KEGGpathway2Graph <- function (pathway, genesOnly = TRUE, expandGenes = TRUE) 
{
  stopifnot(is(pathway, "KEGGPathway"))
  pathway <- splitKEGGgroup(pathway)
  if (expandGenes) {
    pathway <- expandKEGGPathway(pathway)
  }
  knodes <- nodes(pathway)
  kedges <- unique(edges(pathway))
  node.entryIDs <- getEntryID(knodes)
  edge.entryIDs <- getEntryID(kedges)
  V <- node.entryIDs
  edL <- vector("list", length = length(V))
  names(edL) <- V
  if (is.null(nrow(edge.entryIDs))) {
    for (i in seq(along = edL)) {
      edL[[i]] <- list()
    }
  }
  else {
    for (i in 1:length(V)) {
      id <- node.entryIDs[i]
      hasRelation <- id == edge.entryIDs[, "Entry1ID"]
      if (!any(hasRelation)) {
        edL[[i]] <- list(edges = NULL)
      }
      else {
        entry2 <- unname(edge.entryIDs[hasRelation, "Entry2ID"])
        edL[[i]] <- list(edges = entry2)
      }
    }
  }
  gR <- new("graphNEL", nodes = V, edgeL = edL, edgemode = "directed")
  names(kedges) <- sapply(kedges, function(x) paste(getEntryID(x), 
                                                    collapse = "~"))
  env.node <- new.env()
  env.edge <- new.env()
  assign("nodes", knodes, envir = env.node)
  assign("edges", kedges, envir = env.edge)
  nodeDataDefaults(gR, "KEGGNode") <- env.node
  edgeDataDefaults(gR, "KEGGEdge") <- env.edge
  if (genesOnly) {    
    gR <- subGraphByNodeType(gR, "gene")
  }
  return(gR)
}

#' Modified version of the same function from KEGGgraph
#' 
#' @keywords internal
subGraphByNodeType <- function (graph, type = "gene") 
{
  kegg.node.data <- getKEGGnodeData(graph)
  types <- sapply(kegg.node.data, getType)
  isType <- grep(type, types)
  if (!any(isType)) {
    stop("No '", type, "' type found in the file, maybe it is a map file. Please try parsing the file with 'genesOnly=FALSE'\n")
  }
  new.nodes <- names(types[isType])
  new.edges <- edges(graph)
  new.edges <- new.edges[names(new.edges) %in% new.nodes]
  new.edges <- lapply(new.edges, function(eL) return(eL[eL %in% new.nodes]))
  
  subgraph <- new("graphNEL", new.nodes, new.edges, edgemode = "directed")
    
  subnodes <- new.nodes
  subedges <- getRgraphvizEdgeNames(subgraph)
  keggnodes <- get("nodes", nodeDataDefaults(graph, "KEGGNode"))
  keggedges <- get("edges", edgeDataDefaults(graph, "KEGGEdge"))
  subkeggnodes <- keggnodes[subnodes]
  subkeggedges <- keggedges[subedges]
  env.node <- new.env()
  env.edge <- new.env()
  assign("nodes", subkeggnodes, envir = env.node)
  assign("edges", subkeggedges, envir = env.edge)
  nodeDataDefaults(subgraph, "KEGGNode") <- env.node
  edgeDataDefaults(subgraph, "KEGGEdge") <- env.edge
  
  return(subgraph)
}

test_nodeWeights <- function()
{
  V <- LETTERS[1:4]
  g <- graphNEL(nodes = V, edgemode = "directed")
  
  checkEquals(length(nodeWeights(g)), length(nodes(g)))
  checkEquals(nodeWeights(g, "B"), 1, checkNames=FALSE)
  checkEquals(nodeWeights(g, "A", attr = "WT", default = 3), 3, checkNames=FALSE)
}

%\VignetteIndexEntry{ROntoTools}
%\VignetteDepends{ROntoTools}
%\VignettePackage{ROntoTools}


\documentclass[11pt]{article}

\usepackage{hyperref}
\usepackage[margin=1in]{geometry}

\newcommand{\Rfunction}[1]{{\texttt{#1}}}
\newcommand{\Rmethod}[1]{{\texttt{#1}}}

\newcommand{\Robject}[1]{{\texttt{#1}}}
\newcommand{\Rpackage}[1]{{\textit{#1}}}
\newcommand{\Rclass}[1]{{\textit{#1}}}


\begin{document}
\SweaveOpts{concordance=TRUE}
\title{ROntoTools: The R Onto-Tools suite}
\author{Calin Voichita, Sahar Ansari and Sorin Draghici\\
Department of Computer Science, Wayne State University, Detroit MI 48201}
\maketitle

\begin{abstract}
%This package contains the R implementation of the web-based data mining and analysis suite tools called Onto-Tools.  Among these,  Onto-Express (OE) was the first publicly available tool for the GO profiling of high throughput data. The paper describing it and a follow up paper discussing various statistical models that can be used for this purpose~\cite{Khatri:2002, DraghiciOE2:2003} summed up over 450 citations to date. OE was then followed by
%Onto-Compare~\cite{DraghiciOT:2003,DraghiciOC:2003},
%Onto-Design~\cite{DraghiciOT:2003,DraghiciOT:2004},
%Onto-Translate~\cite{DraghiciOT:2003,DraghiciOT:2005,DraghiciOT:2006,DraghiciOntoTranslate:2006}, Onto-Miner~\cite{DraghiciOT:2004},
% Promoter-Express~\cite{DraghiciOT:2006,DraghiciValmik:2005}, nsSNPCounter~\cite{DraghiciOT:2006}
%OE2GO~\cite{Khatri:2007}, and Pathway-Express~\cite{DraghiciPE:2007,Khatri:2007a}. We currently have over 10,000 registered users  from 53 countries. Approximately, 5,000 of these are regular users (more than 10 data sets processed). This R package will provide these users with access to the direct functionalities of the online version, to new analysis methods and also expose the tools to a larger audience.

This package is indented to be the R implementation of the web-based data mining and analysis suite of tools called Onto-Tools~\cite{Khatri:2002, DraghiciOE2:2003, DraghiciOT:2003, DraghiciOC:2003, DraghiciOT:2004, DraghiciOT:2003, DraghiciOT:2005, DraghiciOT:2006, DraghiciOntoTranslate:2006, DraghiciOT:2004, DraghiciOT:2006, DraghiciValmik:2005, DraghiciOT:2006, Khatri:2007, DraghiciPE:2007,Khatri:2007a}. 
Among these,  Onto-Express (OE) was the first publicly available tool for the GO profiling of high throughput data and Pathway-Express (PE) the first tool to perform analysis of signaling pathways using important biological factors like all the interactions between the genes, the type of interaction between them and the position and magnitude of expression change for all the differentially expressed genes. 
We currently have over 10,000 registered users  from 53 countries. Approximately, 5,000 of these are regular users (more than 10 data sets processed).
This R package will provide these users with access to the direct functionalities of the online version, to new analysis methods and also expose the tools to a larger audience. 
As part of the first version, the pathway analysis tool Pathway-Express is made available.

\end{abstract}


\section{Pathway-Express}

Pathway-Express (\Rmethod{pe}) is a tool for the analysis of signaling pathways.
Besides the original implementation~\cite{DraghiciPE:2007, TarcaSPIA:2009}, this tool implements a number of improvements proposed in~\cite{Voichita:2012} that include the incorporation of gene significance and the elimination of the need to select differentially expressed genes.
Pathway-Express uses two sources of data: one is the experiment data and the other is the database of pathways.

\subsection{Pathway database}

Pathway-Express is a general tool that accepts any set of signaling pathways defined using the standard implementation provided in the \Rpackage{graph} package. The only requirement is that each pathway, defined as an object of type \Rclass{graph}, has a weight defined for each edge, representing the efficiency of the propagation between the two genes, and a weight for each node, that will capture the type of gene or the significance of the measured expression change.
This package provides tools to access the KEGG database for signaling pathways and also tools to set these weights.

For example, to download and parse the signaling pathways available in KEGG use:
<<eval=TRUE, echo=TRUE>>=
require(graph)
require(ROntoTools)
kpg <- keggPathwayGraphs("hsa", verbose = FALSE)
@

The above code will load the available cached data for human (i.e., KEGG id \emph{hsa}). To update the cache and download the latest KEGG pathways available use the \Rfunction{updateCache} parameter:
<<eval=FALSE, echo=TRUE>>=
kpg <- keggPathwayGraphs("hsa", updateCache = TRUE, verbose = TRUE)
@
\noindent This command is time consuming and depends on the available bandwith.


The \Robject{kpg} is a list of \Rclass{graph} objectes:
<<eval=TRUE, echo=TRUE>>=
head(names(kpg))
@

\noindent To inspect one of the pathway graphs, only the ID is required. Here is an example for the Cell Cycle: %(Fig.~\ref{fig:cellCycle}):
<<eval=TRUE, echo=TRUE>>=
kpg[["path:hsa04110"]]
head(nodes(kpg[["path:hsa04110"]]))
head(edges(kpg[["path:hsa04110"]]))
@

In addition the parser extracted the type of interaction for each gene-gene interaction in an attribute called \Rfunction{subtype}:
<<eval=TRUE, echo=TRUE>>=
head(edgeData(kpg[["path:hsa04110"]], attr = "subtype"))
@

Using this attribute the function \Rfunction{setEdgeWeights} sets the same weight for all the interactions of the same type:
<<eval=TRUE, echo=TRUE>>=
kpg <- setEdgeWeights(kpg, edgeTypeAttr = "subtype", 
	edgeWeightByType = list(activation = 1, inhibition = -1, 
		expression = 1, repression = -1), 
	defaultWeight = 0)
@

At this point, \Robject{kpg} contains a list of graphs with weighted edges:
<<eval=TRUE, echo=TRUE>>=
head(edgeData(kpg[["path:hsa04110"]], attr = "weight"))
@

To retrieve the title of the pathways and not just their ids the function \Rfunction{keggPathwayNames} can be used:
<<eval=TRUE, echo=TRUE>>=
kpn <- keggPathwayNames("hsa")
head(kpn)
@


\subsection{Experiment data}

As an example, we provided a pre-processed data set from ArrayExpress (\href{http://www.ebi.ac.uk/arrayexpress/experiments/E-GEOD-21942/}{E-GEOD-21942}) that studies the expression change in peripheral blood mononuclear cells (PBMC) between 12 MS patients and 15 controls. The data was preprocessed using the \Rpackage{limma} package. Only probe sets with a gene associated to them have been kept and for each gene only the most significant probe set has been selected (the table is already ordered by p-value):

<<eval=TRUE, echo=TRUE>>=
load(system.file("extdata/E-GEOD-21942.topTable.RData", package = "ROntoTools"))
head(top)
@

%The next step is to eliminate probes with no associated gene:
%<<eval=TRUE, echo=TRUE>>=
%top <- top[!is.na(top$entrez),]
%head(top)
%@
%
%For each gene keep only the most significant probe (the table is already ordered by p-value):
%<<eval=TRUE, echo=TRUE>>=
%top <- top[!duplicated(top$entrez),]
%head(top)
%@

Select differentially expressed genes at 1\% and save their fold change in a vector $fc$ and their p-values in a vector $pv$:
<<eval=TRUE, echo=TRUE>>=
fc <- top$logFC[top$adj.P.Val <= .01]
names(fc) <- top$entrez[top$adj.P.Val <= .01]

pv <- top$P.Value[top$adj.P.Val <= .01]
names(pv) <- top$entrez[top$adj.P.Val <= .01]

head(fc)

head(pv)
@

Alternatively, an analysis with all genes can be performed:
<<eval=TRUE, echo=TRUE>>=
fcAll <- top$logFC
names(fcAll) <- top$entrez

pvAll <- top$P.Value
names(pvAll) <- top$entrez
@

The reference contains all the genes measured in the analysis:
<<eval=TRUE, echo=TRUE>>=
ref <- top$entrez
head(ref)
@

\subsection{Setting the node weights}

The node weights are used to encode for the significance of each gene,  the term described as $\alpha$ in \cite{Voichita:2012}. The two alternative formulas to incorporate the gene significance:
\begin{equation}
\alpha = 1 - p /  p_{thr}~and~\alpha =  - log( p /  p_{thr})
\end{equation}
are implemented as two function \Rfunction{alpha1MR} and \Rfunction{alphaMLG}.

To set the node weights the function \Rfunction{setNodeWeights} is used:
<<eval=TRUE, echo=TRUE>>=
kpg <- setNodeWeights(kpg, weights = alphaMLG(pv), defaultWeight = 1)
head(nodeWeights(kpg[["path:hsa04110"]]))
@

\subsection{Pathway analysis and results summary}

Up to this point all the pieces need for the analysis have been assembled:
\begin{itemize}
\item the pathway database with the experiment specific gene significance - \Robject {kpg}
\item the experiment data - \Robject{fc} and \Robject{ref}
\end{itemize}

\noindent To perform the analysis the function \Rfunction{pe} is used (increase the parameter \Robject{nboot} to obtain more accurate results):
<<eval=TRUE, echo=TRUE>>=
peRes <- pe(x = fc, graphs = kpg, ref = ref,  nboot = 200, verbose = FALSE)
@

The result object can be summarized in a table format with the desired columns using the function \Rfunction{Summary}:
<<eval=TRUE, echo=TRUE>>=
head(Summary(peRes))

head(Summary(peRes, pathNames = kpn, totalAcc = FALSE, totalPert = FALSE,
             pAcc = FALSE, pORA = FALSE, comb.pv = NULL, order.by = "pPert"))
@

\subsection{Graphical representation of results}

To visualize the summary of the Pathway-Express results use the function \Rfunction{plot} (see Fig.~\ref{fig:twoway}):

<<label=peRes_twoway1,include=FALSE>>=
plot(peRes)
@

<<label=peRes_twoway2,include=FALSE>>=
plot(peRes, c("pAcc", "pORA"), comb.pv.func = compute.normalInv, threshold = .01)
@

\begin{figure}
\begin{center}
\resizebox{!}{4in}{
<<label=fig1,fig=TRUE,echo=FALSE>>=
<<peRes_twoway1>>
@
}
\resizebox{!}{4in}{
<<label=fig2,fig=TRUE,echo=FALSE>>=
<<peRes_twoway2>>
@
}
\end{center}
\caption{Two-way plot of Pathway-Express result}
\label{fig:twoway}
\end{figure}

Pathway level statistics can also be displayed one at a time using the function \Rfunction{plot}~(see Fig.~\ref{fig:pePathway_pAcc}):

<<label=pePathway_twoway_Acc,include=FALSE>>=
plot(peRes@pathways[["path:hsa05216"]], type = "two.way")
@

<<label=pePathway_boot_Acc,include=FALSE>>=
plot(peRes@pathways[["path:hsa05216"]], type = "boot")
@

\begin{figure}
\begin{center}
\resizebox{!}{4in}{
<<label=fig3,fig=TRUE,echo=FALSE>>=
<<pePathway_twoway_Acc>>
@
}
\resizebox{!}{4in}{
<<label=fig4,fig=TRUE,echo=FALSE>>=
<<pePathway_boot_Acc>>
@
}
\end{center}
\caption{Pathway level statistiscs: perturbation accumulation versus the measured expression change (above) and the bootstrap simulations of the perturbation accumulation (below).}
\label{fig:pePathway_pAcc}
\end{figure}

To visualize the propagation across the pathway, two functions - \Rfunction{peNodeRenderInfo} and \Rfunction{peEdgeRenderInfo} - are provided to extract the required information from a \Robject{pePathway} object:

<<label=pePathway_graph_Pert,include=FALSE>>=
p <- peRes@pathways[["path:hsa05216"]]
g <- layoutGraph(p@map, layoutType = "dot")
graphRenderInfo(g) <- list(fixedsize = FALSE)
edgeRenderInfo(g) <- peEdgeRenderInfo(p)
nodeRenderInfo(g) <- peNodeRenderInfo(p)
renderGraph(g)
@

This is the \emph{Thyroid cancer} signaling pathway and is shown in Fig.~\ref{fig:pePathway_graph}. Another example is the \emph{T cell receptor signaling pathway} and is presented in Fig.~\ref{fig:pePathway_graph2}.

<<label=pePathway_graph_Pert2,include=FALSE,echo=FALSE>>=
p <- peRes@pathways[["path:hsa04660"]]
g <- layoutGraph(p@map, layoutType = "dot")
graphRenderInfo(g) <- list(fixedsize = FALSE)
edgeRenderInfo(g) <- peEdgeRenderInfo(p)
nodeRenderInfo(g) <- peNodeRenderInfo(p)
renderGraph(g)
@


\begin{figure}
\begin{center}
\resizebox{!}{4in}{
<<label=fig5,fig=TRUE,echo=FALSE>>=
<<pePathway_graph_Pert>>
@
}
\end{center}
\caption{Perturbation propagation on the  \emph{Thyroid cancer signaling pathway}. }
\label{fig:pePathway_graph}
\end{figure}

\begin{figure}
\begin{center}
\resizebox{!}{6.5in}{
<<label=fig6,fig=TRUE,echo=FALSE>>=
<<pePathway_graph_Pert2>>
@
}
\end{center}
\caption{Perturbation propagation on the \emph{T cell receptor signaling pathway}.}
\label{fig:pePathway_graph2}
\end{figure}

\section{Primary dis\--regulation}
Primary dis\--regulation analysis (\Rmethod{pDis}) is a tool for the analysis of signaling pathways.
This is the original implementation of the algorithm introduced in \cite{ansari2016novel}. This method takes into consideration the primary dis\--regulation of a given gene itself and the effects of signaling coming from upstream.
Similar to Pathway Express, primary dis\--regulation uses two sources of data: one is the experiment data and the other is the database of pathways.

The pathway database can be obtained from KEGG as expalined in section Pathway database.

For example, to download and parse the signaling pathways available in KEGG use:
<<eval=TRUE, echo=TRUE>>=
require(graph)
require(ROntoTools)
kpg <- keggPathwayGraphs("hsa", verbose = FALSE)
@

The above code will load the available cached data for human (i.e., KEGG id \emph{hsa}). To update the cache and download the latest KEGG pathways available use the \Rfunction{updateCache} parameter:
<<eval=FALSE, echo=TRUE>>=
kpg <- keggPathwayGraphs("hsa", updateCache = TRUE, verbose = TRUE)
@
\noindent This command is time consuming and depends on the available bandwith.

To retrieve the title of the pathways and not just their ids the function \Rfunction{keggPathwayNames} can be used:
<<eval=TRUE, echo=TRUE>>=
kpn <- keggPathwayNames("hsa")
head(kpn)
@


As an example, a publicly avaiable data is provided in the package. For more information please refer to Experimental data section. 

<<eval=TRUE, echo=TRUE>>=
load(system.file("extdata/E-GEOD-21942.topTable.RData", package = "ROntoTools"))
head(top)
@

%The next step is to eliminate probes with no associated gene:
%<<eval=TRUE, echo=TRUE>>=
%top <- top[!is.na(top$entrez),]
%head(top)
%@
%
%For each gene keep only the most significant probe (the table is already ordered by p-value):
%<<eval=TRUE, echo=TRUE>>=
%top <- top[!duplicated(top$entrez),]
%head(top)
%@

Select differentially expressed genes at 1\% and save their fold change in a vector $fc$ and their p-values in a vector $pv$:
<<eval=TRUE, echo=TRUE>>=
fc <- top$logFC[top$adj.P.Val <= .01]
names(fc) <- top$entrez[top$adj.P.Val <= .01]

pv <- top$P.Value[top$adj.P.Val <= .01]
names(pv) <- top$entrez[top$adj.P.Val <= .01]

head(fc)

head(pv)
@

Alternatively, an analysis with all genes can be performed:
<<eval=TRUE, echo=TRUE>>=
fcAll <- top$logFC
names(fcAll) <- top$entrez

pvAll <- top$P.Value
names(pvAll) <- top$entrez
@

The reference contains all the genes measured in the analysis:
<<eval=TRUE, echo=TRUE>>=
ref <- top$entrez
head(ref)
@

\subsection{Pathway analysis and results summary}

Here are the input needed to run a sample test:
\begin{itemize}
\item the pathway database with the experiment specific gene significance - \Robject {kpg}
\item the experiment data - \Robject{fc} and \Robject{ref}
\end{itemize}

\noindent To perform the analysis the function \Rfunction{pDis} is used (increase the parameter \Robject{nboot} to obtain more accurate results):
<<eval=TRUE, echo=TRUE>>=
pDisRes <- pDis(x = fc, graphs = kpg, ref = ref,  nboot = 200, verbose = FALSE)
@

The result object can be summarized in a table format with the desired columns using the function \Rfunction{Summary}:
<<eval=TRUE, echo=TRUE>>=
head(Summary(pDisRes))

head(Summary(pDisRes, pathNames = kpn, totalpDis = FALSE,
              pORA = FALSE, comb.pv = NULL, order.by = "ppDis"))
@



\bibliographystyle{abbrv}
\bibliography{rontotools}

\end{document}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/utils.R
\name{compute.fisher}
\alias{compute.fisher}
\title{Combine independent p-values using the Fisher method}
\usage{
compute.fisher(p, eps = 1e-06)
}
\arguments{
\item{p}{a vector of independent p-values}

\item{eps}{the minimal p-value considered (all p-values smaller will be set to this value)}
}
\value{
the combined p-value
}
\description{
Combine independent p-values using the Fisher method
}
\examples{

p <- c(.1, .01)
compute.fisher(p)

}
\author{
Calin Voichita and Sorin Draghici
}
\references{
Tarca AL., Draghici S., Khatri P., Hassan SS., Kim J., Kim CJ., Kusanovic JP., Romero R.: "A Signaling Pathway Impact Analysis for Microarray Experiments", 2008, Bioinformatics, 2009, 25(1):75-82.
}
\seealso{
\code{\link{pe}},\code{\link{compute.normalInv}}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/renderInfo-methods.R
\name{peNodeRenderInfo}
\alias{peNodeRenderInfo}
\title{Extract node render information from a \code{pePathway-class} object}
\usage{
peNodeRenderInfo(x, y = "Pert", input.shape = "box",
  default.shape = "ellipse", pos.col = "red", neg.col = "blue",
  zero.col = "white")
}
\arguments{
\item{x}{an object of class \code{\link{pePathway-class}}}

\item{y}{a string representing the factor to be represented (\code{Pert, Acc} or \code{input}; see \code{\link{pePathway-class}})}

\item{input.shape}{shape of nodes that have measured expression change}

\item{default.shape}{shape of all other nodes}

\item{pos.col}{color of nodes with a positive \code{y} factor}

\item{neg.col}{color of nodes with a negative \code{y} factor}

\item{zero.col}{color of nodes with the \code{y} factor equal to zero}
}
\value{
a named list as expected by \code{\link{nodeRenderInfo}}
}
\description{
Extract node render information from a \code{pePathway-class} object
}
\examples{

# load experiment
load(system.file("extdata/E-GEOD-21942.topTable.RData", package = "ROntoTools"))
fc <- top$logFC[top$adj.P.Val <= .01]
names(fc) <- top$entrez[top$adj.P.Val <= .01]
ref <- top$entrez

# load the set of pathways
kpg <- keggPathwayGraphs("hsa")
kpg <- setEdgeWeights(kpg)
kpg <- setNodeWeights(kpg, defaultWeight = 1)

# perform the pathway analysis
peRes <- pe(fc, graphs = kpg, ref = ref, nboot = 100, verbose = TRUE)

p <- peRes@pathways[[50]]
g <- layoutGraph(p@map, layoutType = "dot")
graphRenderInfo(g) <- list(fixedsize = FALSE)
edgeRenderInfo(g) <- peEdgeRenderInfo(p)
nodeRenderInfo(g) <- peNodeRenderInfo(p)
# notice the different type of nodes in the graph (box/circle)
# the color of each node represents the perturbation (red = positive, blue = negative)
# the shade represents the stregth of the perturbation 
renderGraph(g)

nodeRenderInfo(g) <- peNodeRenderInfo(p, "Acc")
# now, the color of each node represents the accumulation (red = positive, blue = negative)
# notice that square nodes with no parents have no accumulation
renderGraph(g)

}
\author{
Calin Voichita and Sorin Draghici
}
\seealso{
\code{\link{nodeRenderInfo}},\code{\link{par}}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/keggDataREST.R
\name{keggPathwayNames}
\alias{keggPathwayNames}
\title{Obtain KEGG pathway titles}
\usage{
keggPathwayNames(organism = "hsa", updateCache = FALSE, verbose = TRUE)
}
\arguments{
\item{organism}{organism code as defined by KEGG}

\item{updateCache}{re-download KEGG data}

\item{verbose}{show progress of downloading and parsing}
}
\value{
A named vector of pathway titles. The names of the vector are the pathway KEGG IDs.
}
\description{
Obtain KEGG pathway titles
}
\examples{

kpn <- keggPathwayNames("hsa")

# to update the pathway cache for human run:
# kpn <- keggPathwayNames("hsa", updateCache = TRUE)
# this is time consuming and depends on the available bandwidth.

head(kpn)

}
\author{
Calin Voichita and Sorin Draghici
}
\seealso{
\code{\link{keggPathwayGraphs}}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/plot-methods.R
\docType{methods}
\name{plot,pePathway,missing-method}
\alias{plot,pePathway,character-method}
\alias{plot,pePathway,missing-method}
\title{Plot pathway level statistics}
\usage{
\S4method{plot}{pePathway,missing}(x, y, ..., type = "two.way", eps = 1e-06)

\S4method{plot}{pePathway,character}(x, y, main = "", ..., type = "two.way",
  eps = 1e-06)
}
\arguments{
\item{x}{an object of type \code{\link{pePathway-class}}}

\item{y}{if provided, the factor to be ploted (either \code{Acc} (default) or \code{Pert}; see \code{\link{pePathway-class}})}

\item{...}{Arguments to be passed to methods, such as \code{\link{par}}}

\item{type}{type of plot (either \code{two.way} (default) or \code{boot})}

\item{eps}{any value smaller than this will be ploted as 0}

\item{main}{title}
}
\description{
Display graphical representation of pathway level statistic like:
i) two way comparison between the measured expression change and one of the 
factors computed by Pathway-Express (\code{\link{pe}}) or ii) the boostrap 
statistics of the same factors.
}
\examples{

# load experiment
load(system.file("extdata/E-GEOD-21942.topTable.RData", package = "ROntoTools"))
fc <- top$logFC[top$adj.P.Val <= .01]
names(fc) <- top$entrez[top$adj.P.Val <= .01]
ref <- top$entrez

# load the set of pathways
kpg <- keggPathwayGraphs("hsa")
kpg <- setEdgeWeights(kpg)
kpg <- setNodeWeights(kpg, defaultWeight = 1)

# perform the pathway analysis (for more accurate results use nboot = 2000)
peRes <- pe(fc, graphs = kpg, ref = ref, nboot = 100, verbose = TRUE)

plot(peRes@pathways[[50]])

plot(peRes@pathways[[50]], "Pert", main = "Perturbation factor")

plot(peRes@pathways[[50]], type = "boot")

plot(peRes@pathways[[50]], "Pert", type = "boot", main = "Perturbation factor")

}
\author{
Calin Voichita and Sorin Draghici
}
\seealso{
\code{\link{pe}}, \code{\link{plot,peRes,missing-method}}, \code{\link{peNodeRenderInfo}}, \code{\link{peEdgeRenderInfo}}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/plot-methods.R
\docType{methods}
\name{plot,peRes,missing-method}
\alias{plot,peRes,character-method}
\alias{plot,peRes,missing-method}
\title{Plot Pathway-Express result}
\usage{
\S4method{plot}{peRes,missing}(x, y, ..., comb.pv.func = compute.fisher,
  adjust.method = "fdr", threshold = 0.05, eps = 1e-06)

\S4method{plot}{peRes,character}(x, y, ..., comb.pv.func = compute.fisher,
  adjust.method = "fdr", threshold = 0.05, eps = 1e-06)
}
\arguments{
\item{x}{an object of type \code{\link{peRes-class}}}

\item{y}{vector of two p-values names to be combined using \code{comb.pv.func} (default: \code{c("pAcc", "pORA")}).}

\item{...}{Arguments to be passed to methods, such as \code{\link{par}}.}

\item{comb.pv.func}{the function to combine the p-values - takes as input a vector of p-values 
and returns the combined p-value (default: \code{\link{compute.fisher}}).}

\item{adjust.method}{the name of the method to adjust the p-value (see \code{\link{p.adjust}})}

\item{threshold}{corrected p-value threshold}

\item{eps}{any value smaller than this will be considered as \code{eps} (default: \code{1e-6}).}
}
\description{
Display a two-way plot using two of the p-values from the Pathway-Express analysis.
}
\examples{

# load experiment
load(system.file("extdata/E-GEOD-21942.topTable.RData", package = "ROntoTools"))
fc <- top$logFC[top$adj.P.Val <= .01]
names(fc) <- top$entrez[top$adj.P.Val <= .01]
ref <- top$entrez

# load the set of pathways
kpg <- keggPathwayGraphs("hsa")
kpg <- setEdgeWeights(kpg)
kpg <- setNodeWeights(kpg, defaultWeight = 1)

# perform the pathway analysis (for more accurate results use nboot = 2000)
peRes <- pe(fc, graphs = kpg, ref = ref, nboot = 100, verbose = TRUE)

plot(peRes)

plot(peRes, c("pPert","pORA"), comb.pv.func = compute.normalInv, threshold = .01)

}
\author{
Calin Voichita and Sorin Draghici
}
\seealso{
\code{\link{pe}}, \code{\link{summary.peRes}}, \code{\link{plot,pePathway,missing-method}}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/Summary-methods.R
\docType{methods}
\name{Summary,peRes-method}
\alias{Summary,peRes-method}
\title{Summarize the results of a Pathway-Express analysis}
\usage{
\S4method{Summary}{peRes}(x, ..., na.rm = FALSE)
}
\arguments{
\item{x}{Pathway-Express analysis result object obtained using \code{\link{pe}}}

\item{...}{see \code{\link{summary.peRes}}}

\item{na.rm}{ignored}
}
\description{
Summarize the results of a Pathway-Express analysis
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/Summary-methods.R
\docType{methods}
\name{Summary,pDisRes-method}
\alias{Summary,pDisRes-method}
\title{Summarize the results of a Pathway-Express analysis}
\usage{
\S4method{Summary}{pDisRes}(x, ..., na.rm = FALSE)
}
\arguments{
\item{x}{Primary dis-regulation analysis result object obtained using \code{\link{pDis}}}

\item{...}{see \code{\link{summary.pDisRes}}}

\item{na.rm}{ignored}
}
\description{
Summarize the results of a Pathway-Express analysis
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/pDisExpress.R
\name{pDis}
\alias{pDis}
\title{Primary dis-regulation: Pathway analysis approach based on the unexplained dis-regulation of genes}
\usage{
pDis(x, graphs, ref = NULL, nboot = 2000, verbose = TRUE,
  cluster = NULL, seed = NULL)
}
\arguments{
\item{x}{named vector of log fold changes for the differentially expressed genes; \code{names(x)} must use the same id's as \code{ref} and the nodes of the \code{graphs}}

\item{graphs}{list of pathway graphs as objects of type \code{graph} (e.g., \code{\link{graphNEL}}); the graphs must be weighted graphs (i.e., have an attribute \code{weight} for both nodes and edges)}

\item{ref}{the reference vector for all genes in the analysis; if the reference is not provided or it is identical to \code{names(x)} a cut-off free analysis is performed}

\item{nboot}{number of bootstrap iterations}

\item{verbose}{print progress output}

\item{cluster}{a cluster object created by makeCluster for parallel computations}

\item{seed}{an integer value passed to set.seed() during the boostrap permutations}
}
\value{
An object of class \code{\link{pDisRes-class}}.
}
\description{
Primary dis-regulation: Pathway analysis approach based on the unexplained dis-regulation of genes
}
\details{
See details in the cited articles.
}
\examples{

# load a multiple sclerosis study (public data available in Array Express 
# ID: E-GEOD-21942)
# This file contains the top table, produced by the limma package with 
# added gene information. All the probe sets with no gene associate to them,
# have been removed. Only the most significant probe set for each gene has been
# kept (the table is already ordered by p-value)
# The table contains the expression fold change and signficance of each  
# probe set in peripheral blood mononuclear cells (PBMC) from 12 MS patients
# and 15 controls.
load(system.file("extdata/E-GEOD-21942.topTable.RData", package = "ROntoTools"))
head(top)

# select differentially expressed genes at 1\% and save their fold change in a 
# vector fc and their p-values in a vector pv
fc <- top$logFC[top$adj.P.Val <= .01]
names(fc) <- top$entrez[top$adj.P.Val <= .01]

pv <- top$P.Value[top$adj.P.Val <= .01]
names(pv) <- top$entrez[top$adj.P.Val <= .01]

# alternativly use all the genes for the analysis
# NOT RUN: 
# fc <- top$logFC
# names(fc) <- top$entrez

# pv <- top$P.Value
# names(pv) <- top$entrez

# get the reference
ref <- top$entrez

# load the set of pathways
kpg <- keggPathwayGraphs("hsa")

# set the beta information (see the citated documents for meaning of beta)
kpg <- setEdgeWeights(kpg)

# inlcude the significance information in the analysis (see Voichita:2012 
# for more information)
# set the alpha information based on the pv with one of the predefined methods
kpg <- setNodeWeights(kpg, weights = alphaMLG(pv), defaultWeight = 1)

# perform the pathway analysis
# in order to obtain accurate results the number of boostraps, nboot, should 
# be increase to a number like 2000
pDisRes <- pDis(fc, graphs = kpg, ref = ref, nboot = 100, verbose = TRUE)

# obtain summary of results
head(Summary(pDisRes))

}
\author{
Calin Voichita, Sahar Ansari and Sorin Draghici
}
\references{
Voichita C., Donato M., Draghici S.: "Incorporating gene significance in the impact analysis of signaling pathways", IEEE Machine Learning and Applications (ICMLA), 2012 11th International Conference on, Vol. 1, p.126-131, 2012
Ansari, S., Voichita, C., Donato, M., Tagett, R., & Draghici, S. A Novel Pathway Analysis Approach Based on the Unexplained Disregulation of Genes.
}
\seealso{
\code{\link{Summary}}, 
\code{\link{keggPathwayGraphs}}, \code{\link{setNodeWeights}}, \code{\link{setEdgeWeights}}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/AllGenerics.R, R/nodeWeights-methods.R
\docType{methods}
\name{nodeWeights}
\alias{nodeWeights}
\alias{nodeWeights,graph,character-method}
\alias{nodeWeights,graph,missing-method}
\alias{nodeWeights,graph,numeric-method}
\title{Retrieve the node weights of a graph}
\usage{
nodeWeights(object, index, ..., attr = "weight", default = 1)

\S4method{nodeWeights}{graph,character}(object, index, attr, default)

\S4method{nodeWeights}{graph,numeric}(object, index, attr, default)

\S4method{nodeWeights}{graph,missing}(object, index, attr, default)
}
\arguments{
\item{object}{A graph, any object that inherits the \code{graph} class.}

\item{index}{If supplied, a character or numeric vector of node names or indices.}

\item{...}{Unused.}

\item{attr}{The name of the node attribute to use as a weight. You can view the list of defined node attributes and their default values using nodeDataDefaults.}

\item{default}{The value to use if \code{object} has no node attribute named by the value of \code{attr}. The default is the value 1.}
}
\value{
A named vector with the node weights. The names of the vector are the names of the specified \code{index}, or all nodes if \code{index} was not provided.
}
\description{
A generic function that returns the node weights of a graph. If \code{index} is specified, only the weights of the specified nodes are returned. The user can control which node attribute is interpreted as the weight.
}
\details{
The weights of all nodes identified by the \code{index} are returned. If \code{index} is not supplied, the weights of all nodes are returned.

By default, \code{nodeWeights} looks for an node attribute with name "weight" and, if found, uses these values to construct the node weight vector.
You can make use of attributes stored under a different name by providing a value for the \code{attr} argument.
For example, if \code{object} is a graph instance with an node attribute named "WTS", then the call \code{nodeWeights(object, attr="WTS")} will attempt to use those values.

If the graph instance does not have an node attribute with name given by the value of the \code{attr} argument, \code{default} will be used as the weight for all nodes.
Note that if there is an attribute named by \code{attr}, then its default value will be used for nodes not specifically customized.
See nodeData and nodeDataDefaults for more information.
}
\examples{

library(graph)
V <- LETTERS[1:4]
g <- graphNEL(nodes = V, edgemode = "directed")
nodeWeights(g)
nodeWeights(g, "B")
nodeWeights(g, attr = "WT", default = 3)

}
\author{
Calin Voichita and Sorin Draghici
}
\seealso{
\link{nodes}, \link{nodeData}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/graphWeights.R
\name{setEdgeWeights}
\alias{setEdgeWeights}
\title{Set gene weights based on edge type}
\usage{
setEdgeWeights(graphList, edgeTypeAttr = "subtype",
  edgeWeightByType = list(activation = 1, inhibition = -1, expression = 1,
  repression = -1), defaultWeight = 0, combineWeights = sum,
  nodeOnlyGraphs = FALSE)
}
\arguments{
\item{graphList}{a list of \code{\link{graphNEL}} objects}

\item{edgeTypeAttr}{edge attribute to be considered as the edge type. If the edge has multiple types, 
the edge type attribute is considered as a comma separeted list of types}

\item{edgeWeightByType}{named list of weigths, where the names of the list are the 
edge type (values of the attribute defined by \code{edgeTypeAttr})}

\item{defaultWeight}{default value for an edge with a type not defined in \code{edgeWeightByType}}

\item{combineWeights}{for the edges with multiple types, the function to be applied on the vector of weights}

\item{nodeOnlyGraphs}{boolean value marking if graphs with no edges should be returned or not; note that graphs with all edge weights equal to 0 are considered node only graphs}
}
\value{
The \code{graphList} with the edge weights set.
}
\description{
\code{setEdgeWeights}
}
\examples{

# load the set of pathways
kpg <- keggPathwayGraphs("hsa")

kpg <- setEdgeWeights(kpg)

edgeWeights(kpg[["path:hsa04110"]])

}
\author{
Calin Voichita and Sorin Draghici
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/summary.peRes.R
\name{summary.peRes}
\alias{summary.peRes}
\title{Summarize the results of a Pathway-Express analysis}
\usage{
summary.peRes(object, ..., pathNames = NULL, totalAcc = TRUE, totalPert = TRUE, normalize = TRUE, 
 pPert = TRUE, pAcc = TRUE, pORA = TRUE, 
 comb.pv = c("pPert", "pORA"), comb.pv.func = compute.fisher,
 order.by = "pComb", adjust.method = "fdr")
}
\arguments{
\item{object}{Pathways-Express result object obtained using \code{\link{pe}}}

\item{...}{ignored}

\item{pathNames}{named vector of pathway names; the names of the vector are the IDs of the pathways}

\item{totalAcc}{boolean value indicating if the total accumulation should be computed}

\item{totalPert}{boolean value indicating if the total perturbation should be computed}

\item{normalize}{boolean value indicating if normalization with regards to the boostrap simulations should be performed on totalAcc and totalPert}

\item{pPert}{boolean value indicating if the significance of the total perturbation in regards to the bootstrap permutations should be computed}

\item{pAcc}{boolean value indicating if the significance of the total accumulation in regards to the bootstrap permutations should be computed}

\item{pORA}{boolean value indicating if the over-represtation p-value should be computed}

\item{comb.pv}{vector of the p-value names to be combine (any of the above p-values)}

\item{comb.pv.func}{the function to combine the p-values; takes as input a vector of p-values and returns the combined p-value}

\item{order.by}{the name of the p-value that is used to order the results}

\item{adjust.method}{the name of the method to adjust the p-value (see \link{p.adjust})}
}
\description{
Summarize the results of a Pathway-Express analysis
}
\examples{

# load experiment
load(system.file("extdata/E-GEOD-21942.topTable.RData", package = "ROntoTools"))
fc <- top$logFC[top$adj.P.Val <= .01]
names(fc) <- top$entrez[top$adj.P.Val <= .01]
ref <- top$entrez

# load the set of pathways
kpg <- keggPathwayGraphs("hsa")
kpg <- setEdgeWeights(kpg)
kpg <- setNodeWeights(kpg, defaultWeight = 1)

# perform the pathway analysis
peRes <- pe(fc, graphs = kpg, ref = ref, nboot = 100, verbose = TRUE)

# obtain summary of results
head(summary(peRes))

kpn <- keggPathwayNames("hsa")

head(summary(peRes))

head(summary(peRes, pathNames = kpn, totalAcc = FALSE, totalPert = FALSE, 
             pAcc = FALSE, pORA = FALSE, comb.pv = NULL, order.by = "pPert"))

}
\seealso{
\code{\link{pe}}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/AllClasses.R
\docType{class}
\name{peRes-class}
\alias{peRes-class}
\title{Pathway-Express result class}
\description{
This class is used to encode the results of the pathway analysis performed by the function \code{\link{pe}}.
}
\details{
The slots \code{input} and \code{ref} record global information related to the whole analysis, 
while the \code{pathways} slot records the specific results as \code{\link{pePathway-class}} for each one of the pathways used in the analysis.
}
\section{Slots}{
 

\describe{
    \item{\code{pathways}:}{A list of \code{\link{pePathway-class}} objects.}
    \item{\code{input}:}{named vector of fold changes used for the analysis. The names of the vector are the IDs originaly used.}
    \item{\code{ref}:}{character vector containing the IDs used as reference in the analysis.}
    \item{\code{cutOffFree}:}{boolean value indicating if a cut-of-free analysis has been performed.}
  }
}
\author{
Calin Voichita and Sorin Draghici
}
\seealso{
\code{\link{pe}}, \code{\link{pePathway-class}}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/keggDataREST.R
\name{KEGGpathway2Graph}
\alias{KEGGpathway2Graph}
\title{Modified version of the same function from KEGGgraph}
\usage{
KEGGpathway2Graph(pathway, genesOnly = TRUE, expandGenes = TRUE)
}
\description{
Modified version of the same function from KEGGgraph
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/graphWeights.R
\name{setNodeWeights}
\alias{setNodeWeights}
\title{Set node weights}
\usage{
setNodeWeights(graphList, weights = NULL, defaultWeight = 1)
}
\arguments{
\item{graphList}{a list of \code{graph} (e.g., \code{\link{graphNEL}}) objects}

\item{weights}{named vector or matrix; if vector, the node is going to have the same weight in all graphs it appears;
if matrix, the rows represent nodes and columns represent graphs and the node will have different weights in each pathway}

\item{defaultWeight}{the default weight for all nodes not set by the parameter \code{weights}}
}
\value{
The \code{graphList} with the node weights set.
}
\description{
Set node weights
}
\examples{

# load the set of pathways
kpg <- keggPathwayGraphs("hsa")

kpg <- setNodeWeights(kpg)

nodeWeights(kpg[["path:hsa04110"]])


}
\author{
Calin Voichita and Sorin Draghici
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/keggDataREST.R
\name{keggPathwayGraphs}
\alias{keggPathwayGraphs}
\title{Download and parse KEGG pathway data}
\usage{
keggPathwayGraphs(organism = "hsa", targRelTypes = c("GErel", "PCrel",
  "PPrel"), relPercThresh = 0.9, nodeOnlyGraphs = FALSE,
  updateCache = FALSE, verbose = TRUE)
}
\arguments{
\item{organism}{organism code as defined by KEGG}

\item{targRelTypes}{target relation types}

\item{relPercThresh}{percentage of the number of relation types over all possible realtions in the pathway}

\item{nodeOnlyGraphs}{allow graphs with no edges}

\item{updateCache}{re-download KEGG data}

\item{verbose}{show progress of downloading and parsing}
}
\value{
A list of \code{\link{graphNEL}} objects encoding the pathway information.
}
\description{
Download and parse KEGG pathway data
}
\examples{

# The pathway cache provided as part of the pathway contains only the 
# pathways that passed the default filtering. We recommend, re-downloading
# the pathways using the updateCache parameter
kpg <- keggPathwayGraphs("hsa")

# to update the pathway cache for human run:
# kpg <- keggPathwayGraphs("hsa", updateCache = TRUE)
# this is time consuming and depends on the available bandwith.

head(names(kpg))

kpg[["path:hsa04110"]]
head(nodes(kpg[["path:hsa04110"]]))
head(edges(kpg[["path:hsa04110"]]))

}
\author{
Calin Voichita and Sorin Draghici
}
\seealso{
\code{\link{keggPathwayNames}}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/renderInfo-methods.R
\name{peEdgeRenderInfo}
\alias{peEdgeRenderInfo}
\title{Extract edge render information from a \code{pePathway-class} object}
\usage{
peEdgeRenderInfo(x, pos.col = "black", pos.lty = "solid", pos.ah = "vee",
  neg.col = "black", neg.lty = "dashed", neg.ah = "tee",
  zero.col = "lightgray", zero.lty = "dotted", zero.ah = "none")
}
\arguments{
\item{x}{an object of class \code{\link{pePathway-class}}}

\item{pos.col}{color of the edges with possitive weight}

\item{pos.lty}{line type of the edges with possitive weight}

\item{pos.ah}{arrow head of the edges with possitive weight}

\item{neg.col}{color of the edges with negative weight}

\item{neg.lty}{line type of the edges with negative weight}

\item{neg.ah}{arrow head of the edges with negative weight}

\item{zero.col}{color of the edges with zero weight}

\item{zero.lty}{color of the edges with zero weight}

\item{zero.ah}{color of the edges with zero weight}
}
\value{
a named list as expected by \code{\link{edgeRenderInfo}}
}
\description{
Extract edge render information from a \code{pePathway-class} object
}
\examples{

# load experiment
load(system.file("extdata/E-GEOD-21942.topTable.RData", package = "ROntoTools"))
fc <- top$logFC[top$adj.P.Val <= .01]
names(fc) <- top$entrez[top$adj.P.Val <= .01]
ref <- top$entrez

# load the set of pathways
kpg <- keggPathwayGraphs("hsa")
kpg <- setEdgeWeights(kpg)
kpg <- setNodeWeights(kpg, defaultWeight = 1)

# perform the pathway analysis
peRes <- pe(fc, graphs = kpg, ref = ref, nboot = 100, verbose = TRUE)

p <- peRes@pathways[[50]]
g <- layoutGraph(p@map, layoutType = "dot")
graphRenderInfo(g) <- list(fixedsize = FALSE)
edgeRenderInfo(g) <- peEdgeRenderInfo(p)
nodeRenderInfo(g) <- peNodeRenderInfo(p)
# notice the different type of edges in the graph (solid/dashed/dotted) 
renderGraph(g)

}
\author{
Calin Voichita and Sorin Draghici
}
\seealso{
\code{\link{edgeRenderInfo}},\code{\link{par}}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/AllClasses.R
\docType{class}
\name{pDisPathway-class}
\alias{pDisPathway-class}
\title{Class that encodes the result of pDis analysis for a single pathway}
\description{
Class that encodes the result of pDis analysis for a single pathway
}
\section{Slots}{


\describe{
   \item{\code{map}:}{an object of type graph (e.g., \code{\link{graphNEL}}).}
   \item{\code{input}:}{named vector of fold changes for genes on this pathway. The names of the genes are the orignal IDS used in the analysis}
   \item{\code{ref}:}{vector of reference IDs on this pathway}
   \item{\code{boot}:}{an object of class \code{boot} encoding the bootstrap information.}
   \item{\code{pDis}:}{the gene primary dis-regulation for all genes on the pathway, as computed by primary dis-regulation.}
   \item{\code{asGS}:}{pathway was considered as gene set}
}
}
\author{
Calin Voichita, Sahar Ansari and Sorin Draghici
}
\seealso{
\code{\link{pDis}}, \code{\link{pDisRes-class}}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/keggDataREST.R
\name{subGraphByNodeType}
\alias{subGraphByNodeType}
\title{Modified version of the same function from KEGGgraph}
\usage{
subGraphByNodeType(graph, type = "gene")
}
\description{
Modified version of the same function from KEGGgraph
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/utils.R
\name{alpha1MR}
\alias{alpha1MR}
\title{Compute alpha weights}
\usage{
alpha1MR(pv, threshold = max(pv))
}
\arguments{
\item{pv}{vector of p-values}

\item{threshold}{the threshold value that was used to select DE genes}
}
\description{
Transform a vector of p-values into weights.
}
\details{
Computes a set of weights from p-values using the formula \code{1-pv/threshold}.
}
\examples{

load(system.file("extdata/E-GEOD-21942.topTable.RData", package = "ROntoTools"))

head(alpha1MR(top$adj.P.Val))

}
\author{
Calin Voichita and Sorin Draghici
}
\seealso{
\code{\link{pe}}
}
